// MikuMikuTickle(Oculus Rift Ή)
#include <string>
#include <Windows.h>
#include <Windowsx.h> // GET_X_LPARAM / GET_Y_LPARAM
#include <process.h>
#include <d3d11_1.h>
#include <d3dcompiler.h>
#include <directxmath.h>
#include <directxcolors.h>
#include <Shlobj.h>
#include <DirectXTex.h>
#include "OVR.h"
#include "pmd.h"
#include "pmx.h"

// DirectX
#pragma comment(lib,"d3d11.lib")
#pragma comment(lib,"d3dcompiler.lib")
#pragma comment(lib,"DirectXTex.lib")

// Oculus
#pragma comment(lib,"libovr.lib")
#pragma comment(lib,"winmm.lib")

// LeapMotion
#if defined( DEBUG ) || defined( _DEBUG )
#pragma comment(lib,"leapd.lib")
#else
#pragma comment(lib,"leap.lib")
#endif

// Bullet
#if defined( DEBUG ) || defined( _DEBUG )
#pragma comment(lib,"BulletDynamics_vs2010_debug.lib")
#pragma comment(lib,"BulletCollision_vs2010_debug.lib")
#pragma comment(lib,"LinearMath_vs2010_debug.lib")
#else
#pragma comment(lib,"BulletDynamics_vs2010.lib")
#pragma comment(lib,"BulletCollision_vs2010.lib")
#pragma comment(lib,"LinearMath_vs2010.lib")
#endif

using namespace DirectX;

#include "DXCommon.h"
#include "PMDXWork.h"
#include "LMCHand.h"
#include "PMDXBullet.h"
#include "UIPanels.h"

HINSTANCE               g_hInst = nullptr;
HWND                    g_hWnd = nullptr;
D3D_DRIVER_TYPE         g_driverType = D3D_DRIVER_TYPE_NULL;
D3D_FEATURE_LEVEL       g_featureLevel = D3D_FEATURE_LEVEL_11_0;
ID3D11Device*           g_pd3dDevice = nullptr;
ID3D11DeviceContext*    g_pImmediateContext = nullptr;
IDXGISwapChain*         g_pSwapChain = nullptr;
ID3D11RenderTargetView* g_pRenderTargetView = nullptr;
ID3D11Texture2D*        g_pDepthStencil = nullptr;
ID3D11DepthStencilView* g_pDepthStencilView = nullptr;
ID3D11VertexShader*     g_pVertexShader = nullptr;
ID3D11VertexShader*     g_pPMDXVertexShader = nullptr;
ID3D11PixelShader*      g_pPixelShader = nullptr;
ID3D11InputLayout*      g_pVertexLayout = nullptr;
ID3D11InputLayout*      g_pPMDXVertexLayout = nullptr;
ID3D11Buffer*           g_pConstantBuffer = nullptr;
ID3D11RasterizerState   *g_pRasterizerStateSingleSide = nullptr;
ID3D11RasterizerState   *g_pRasterizerStateDoubleSide = nullptr;
ID3D11RasterizerState   *g_pRasterizerStateWireframe = nullptr;
ID3D11BlendState        *g_pBlendState = nullptr;
float g_blendFactor[4] = {0.0f, 0.0f, 0.0f, 0.0f};
XMMATRIX                g_World;
UINT g_width;
UINT g_height;
TCHAR *g_sShaderFile = L"shader.fx";

// for OVR
XMMATRIX                g_ProjectionL;
XMMATRIX                g_ProjectionR;
float g_lensViewportShift;
float g_distortionScale;

struct OVRVertex{
  XMFLOAT3 Pos;
  XMFLOAT2 Tex;
};

struct OVRConstantBuffer{
  XMFLOAT2 LensCenter;
  XMFLOAT2 ScreenCenter;
  XMFLOAT2 Scale;
  XMFLOAT2 ScaleIn;
  XMFLOAT4 HmdWarpParam;
};

OVR::HMDInfo                  g_HMDInfo;
OVR::Ptr<OVR::DeviceManager>  g_pOVRManager;
OVR::Ptr<OVR::SensorDevice>   g_pSensor;
OVR::Ptr<OVR::HMDDevice>      g_pHMD;
OVR::SensorFusion            *g_pSFusion=nullptr;
ID3D11VertexShader*       g_pOVRVertexShader=nullptr;
ID3D11PixelShader*        g_pOVRPixelShader=nullptr;
ID3D11Texture2D*          g_pOVRDistortionTx=nullptr;
ID3D11RenderTargetView*   g_pOVRRenderTargetView=nullptr;
ID3D11ShaderResourceView* g_pOVRShaderResourceView=nullptr;
ID3D11InputLayout*        g_pOVRVertexLayout=nullptr;
ID3D11Buffer*             g_pOVRVertexBufferL=nullptr;
ID3D11Buffer*             g_pOVRVertexBufferR=nullptr;
ID3D11Buffer*             g_pOVRIndexBuffer=nullptr;
ID3D11Buffer*             g_pOVRConstantBuffer=nullptr;
TCHAR *g_sOVRShaderFile=L"OVRDist.fx";

// ݎ
ULONGLONG g_now_time;
// ZT[l(Yaŵ)
float g_InitYaw; // l
float g_NowYaw; // ݒl
// _̎pp
float g_EyeYaw=0.0;
float g_EyePitch=0.0;
float g_EyeRoll=0.0;
// _̈ʒu
XMFLOAT3 g_InitEyePos=XMFLOAT3(0.0f, 15.0f, -6.0f);
XMFLOAT3 g_EyePos=g_InitEyePos;
// _x[X
float g_EyeBaseYaw=0.0; //]p(Yaŵ)
XMFLOAT3 g_EyeVelocity=XMFLOAT3(0.0f, 0.0f, 0.0f); // x
float g_EyeSpeed=1.5f; // ړ̑
float g_EyeBaseYawVelocity=0; // px
float g_EyeBaseYawSpeed=15.0f*XM_PI/180.0f; // ]̑
XMMATRIX g_mEyeBase; // ps

// ڂ̈ʒũItZbg
float g_sbase=0.6f;
float g_eyeheight=0.6f;
float g_eyeforward=0.3f;
// PMDƗpf[^
t_PmdxWork g_PmdxWork;
// eNX`Ǘf[^
t_MngTexture *g_listMngTexture=nullptr;
// {[obt@
BoneBuf *g_listBoneBuf=nullptr;

// ȈՃnh𒼕̂̑gݍ킹ŕ`Ă݂
struct t_TklHand{
  t_PmdxWork *pPmdxWork;
  int iBone;
  int isRight; // 0:A1:E
  XMFLOAT4X4 mLocal,mWorld;
};
#define NUM_OF_TKLHAND 4
t_TklHand g_aTklHand[NUM_OF_TKLHAND];
float g_FingerRefAngleNow=0.0f; //ẘpx߂Qƒl
int g_tkl_hand_active[NUM_OF_TKLHAND];
ID3D11Buffer* g_pVertexBufferCube=nullptr;
ID3D11Buffer* g_pIndexBufferCube=nullptr;

// 
XMFLOAT3 g_ft_shackle_L_pos,g_ft_shackle_R_pos;
XMFLOAT3 g_leg_L_pos,g_leg_R_pos;
XMFLOAT3 g_ankle_L_pos,g_ankle_R_pos;
XMFLOAT3 g_knee_L_pos,g_knee_R_pos;
XMFLOAT3 g_knee_L_pos_now,g_knee_R_pos_now;
SimpleVertex g_CrossVertices[24*11];
WORD g_CrossIndices[36*11];
ID3D11Buffer* g_pVertexBufferCross=nullptr;
ID3D11Buffer* g_pIndexBufferCross=nullptr;

// g̋
float g_leg_L_strength=1.0f;
float g_leg_R_strength=1.0f;
float g_knee_L_strength=1.0f;
float g_knee_R_strength=1.0f;
XMFLOAT3 g_arm_L_pos,g_arm_R_pos;
XMFLOAT3 g_ubody_pos,g_ubody2_pos;
XMFLOAT4X4 g_mLUBodyInv;
float g_ubody_breath_z,g_ubody2_breath_z;
int g_flg_SimBodyEnable;

// \CfbNX
int g_morph_idx_blink;
int g_morph_idx_hau;
int g_morph_idx_laugh;
int g_morph_idx_wink;
int g_morph_idx_a;
int g_morph_idx_i;
int g_morph_idx_o;
int g_morph_idx_trbl;
int g_morph_idx_anger;

// 
float g_reaction_blink_time=0.0f;
float g_reaction_blink_interval=0.0;
float g_reaction_tkl_time=0.0f;
float g_reaction_breath_time=0.0f;
float g_reaction_anger_time=0.0f;

// Sp(̏)
float g_leg_open_angle=0.0f;
float g_leg_open_v_angle=0.0f;
float g_leg_front_angle=0.0f;
float g_leg_front_v_angle=0.0f;
float g_leg_s_open_front=10.0f*XM_PI/180.0f;

// {[CfbNX
int g_bone_idx_neck;
int g_bone_idx_head;
int g_bone_idx_r_eye;
int g_bone_idx_leg_L;
int g_bone_idx_leg_R;
int g_bone_idx_knee_L;
int g_bone_idx_knee_R;
int g_bone_idx_ankle_L;
int g_bone_idx_ankle_R;
int g_bone_idx_lbody;
int g_bone_idx_ubody;
int g_bone_idx_ubody2;
int g_bone_idx_arm_L;
int g_bone_idx_arm_R;

// ̊px
float g_fNHAngleX=0.0f;
float g_fNHAngleY=0.0f;

// ̊px
float g_ankles_shake_ref_ange=0.0f;
float g_AnkleLAngleX[2]={0.0f, 0.0f};
float g_AnkleLAngleY[2]={0.0f, 0.0f};

// LMCnh
LMCHand *g_listLMCHand=nullptr;
XMMATRIX g_mWorldLMC;
int g_flgFingerPosVisible=0;
int g_flgLMCMountedOnHMD=0;

// ڐGF
// 0: 1:E 2: 3:E 4: 5:E 6:ӂ͂ 7:Eӂ͂
#define NUM_OF_TOUCHAREA 8
TouchArea g_aTouchArea[NUM_OF_TOUCHAREA];
float g_fTouchValTotal=0.0f;
float g_afTouchValArea[NUM_OF_TOUCHAREA];
XMFLOAT3 g_avTouchCenter[NUM_OF_TOUCHAREA];
int g_flgTouchVisible=0;

// ZpXbh֘A
int g_PysComputing=0; // 0:vZOA1:vZA2:vZA3:I
ULONGLONG g_now_time_pys;
CRITICAL_SECTION g_CriticalSection;
HANDLE g_hEventPys;

// VRpUIpl֘A
extern UIPanel g_aUIPanels[];
int g_MousePos_x,g_MousePos_y;
float g_VRMousePos_x,g_VRMousePos_y;
int g_ui_mouse_down=0;
float g_VRMouseVisibleTime=0.0f;

// vg^Cv錾
HRESULT InitOVRDevice();
HRESULT InitWindow( HINSTANCE hInstance, int nCmdShow );
HRESULT InitDX11Device();
HRESULT SetupOVRDistortion();
HRESULT SetupPMDXWorkForD3D(t_PmdxWork *pPmdxWork);
int search_morph_idx(t_PmdxWork *pPmdxWork,char *morph_name);
void set_morph_rate(t_PmdxWork *pPmdxWork,int idx,float new_rate,
                    float maxspeed,float dt);
void setup_cube_for_hands();
void CrucifyModel(t_PmdxWork *pPmdxWork,int flgInit);
int SetupSimBody(t_PmdxWork *pPmdxWork);
void SetupTklHand(t_PmdxWork *pPmdxWork);
void SetupTouchArea();
void delete_cube_for_hands();
void destroy_g_listMngTexture();
void destroy_g_listBoneBuf();
void CleanupDX11Device();
void ClearCross();
void ClearPmdxWork(t_PmdxWork *pPmdxWork);
void CleanupOVRDevice();
LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );
void ThredSimulatePys(void *pDmy);
void Render();

// \ft@C̎擾
void GetPMDXFilePath(char *rtnPath){
  OPENFILENAME ofn;
  WCHAR workPath[_MAX_PATH]=L"";

  ZeroMemory( &ofn, sizeof(ofn) );
  ofn.lStructSize = sizeof(ofn);
  ofn.hwndOwner = nullptr;
  ofn.lpstrFilter = L"PMD/PMX\0*.pmd;*.pmx\0\0"; // t@C̎
  ofn.lpstrFile = workPath;
  ofn.lpstrFileTitle = nullptr;
  ofn.nMaxFile = _MAX_PATH;
  ofn.nMaxFileTitle = 0;
  ofn.Flags = OFN_FILEMUSTEXIST;
  ofn.lpstrTitle = L"\PMD/PMXt@C̑I";
  ofn.lpstrDefExt = nullptr;

  if(!GetOpenFileName( &ofn )){
//  int ierr=CommDlgExtendedError();
//  if(ierr!=FNERR_BUFFERTOOSMALL);
    workPath[0]='\0';
  }
  wstr2str(rtnPath,workPath,MAX_PATH);
  return;
}

// Gg|Cg
int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,
                   int nCmdShow){
  MSG msg = {0};
  int err_flg=0;
  char *err_str=nullptr;
  WCHAR current_dir[_MAX_PATH];
  WCHAR wcErrMsg[100];

  setlocale( LC_CTYPE, "jpn" );
  GetCurrentDirectory(_MAX_PATH,current_dir);
  ZeroMemory(&g_PmdxWork,sizeof(t_PmdxWork));
  GetPMDXFilePath(g_PmdxWork.PmdxPath);
  int length=strlen(g_PmdxWork.PmdxPath);
  if(length==0) err_flg=1;
  else if((g_PmdxWork.PmdxPath[length-1]=='D')||(g_PmdxWork.PmdxPath[length-1]=='d')){
    if((g_PmdxWork.pmdx_data=create_pmd_data(g_PmdxWork.PmdxPath,&err_str))==nullptr){
      str2wstr(wcErrMsg,err_str,100);
      MessageBox( nullptr,wcErrMsg, L"Error", MB_OK );
      err_flg=1;
    }
  } else if((g_PmdxWork.pmdx_data=create_pmx_data(g_PmdxWork.PmdxPath,&err_str))==nullptr){
    str2wstr(wcErrMsg,err_str,100);
    MessageBox( nullptr,wcErrMsg, L"Error", MB_OK );
    err_flg=1;
  } else{
    g_PmdxWork.isPMX=1;
  }
  SetCurrentDirectory(current_dir);
  if(err_flg==0){
    if(FAILED(InitOVRDevice())) err_flg=1;
  }
  if(err_flg==0){
    if(FAILED(InitWindow( hInstance, nCmdShow )))err_flg=1;
  }
  if(err_flg==0){
    if(FAILED(InitDX11Device())) err_flg=1;
  }
  InitBulletWorld();
  if(err_flg==0){
    if(FAILED(SetupPMDXWorkForD3D(&g_PmdxWork))) err_flg=1;
  }

  if(err_flg==0){
    //\CfbNX̌
    g_morph_idx_blink=search_morph_idx(&g_PmdxWork,"܂΂");
    g_morph_idx_hau=search_morph_idx(&g_PmdxWork,"͂");
    g_morph_idx_laugh=search_morph_idx(&g_PmdxWork,"΂");
    g_morph_idx_wink=search_morph_idx(&g_PmdxWork,"EBN");
    if(g_morph_idx_wink<0) g_morph_idx_wink=search_morph_idx(&g_PmdxWork,"EBN");
    g_morph_idx_a=search_morph_idx(&g_PmdxWork,"");
    g_morph_idx_i=search_morph_idx(&g_PmdxWork,"");
    g_morph_idx_o=search_morph_idx(&g_PmdxWork,"");
    g_morph_idx_trbl=search_morph_idx(&g_PmdxWork,"");
    g_morph_idx_anger=search_morph_idx(&g_PmdxWork,"{");
    // {[CfbNX̌
    g_bone_idx_neck=search_bone_idx(&g_PmdxWork,"");
    g_bone_idx_head=search_bone_idx(&g_PmdxWork,"");
    g_bone_idx_r_eye=search_bone_idx(&g_PmdxWork,"E");
    g_bone_idx_leg_L=search_bone_idx(&g_PmdxWork,"");
    g_bone_idx_leg_R=search_bone_idx(&g_PmdxWork,"E");
    g_bone_idx_knee_L=search_bone_idx(&g_PmdxWork,"Ђ");
    g_bone_idx_knee_R=search_bone_idx(&g_PmdxWork,"EЂ");
    g_bone_idx_ankle_L=search_bone_idx(&g_PmdxWork,"");
    g_bone_idx_ankle_R=search_bone_idx(&g_PmdxWork,"E");
    // ɂ
    CrucifyModel(&g_PmdxWork,1);
    // g̋V~[V
    g_flg_SimBodyEnable=SetupSimBody(&g_PmdxWork);
    // ȈՃnh`
    setup_cube_for_hands();
    SetupTklHand(&g_PmdxWork);
    // ڐGFݒ
    SetupTouchArea();
    // pl̃ZbgAbv
    SetupUIPanels();
    // 擾
    g_now_time=GetTickCount64();
    g_now_time_pys=g_now_time;
    // ZT[lǂݏo
    if(g_pSFusion){
      OVR::Quatf hmdOrient = g_pSFusion->GetOrientation();
      float dmyPitch, dmyRoll;
      hmdOrient.GetEulerAngles<OVR::Axis_Y, OVR::Axis_X, OVR::Axis_Z>(&g_NowYaw, &dmyPitch, &dmyRoll);
      g_InitYaw=g_NowYaw;
    }
    // ZpXbh̏
    InitializeCriticalSection(&g_CriticalSection);
    g_hEventPys=CreateEvent(NULL, TRUE, FALSE, L"EvPys");
    _beginthread(ThredSimulatePys,0,nullptr);
    // }EXʒu̐ݒ
    g_MousePos_x=g_width/2;
    g_MousePos_y=g_height/2;
    // }EXJ[\
    ShowCursor(FALSE);
    // LeapMotioñ|V[tOZbg
    SetLMCPolicy(g_flgLMCMountedOnHMD);

    while( WM_QUIT != msg.message ){
      if(PeekMessage(&msg,nullptr,0,0,PM_REMOVE)){
        TranslateMessage( &msg );
        DispatchMessage( &msg );
      }
      else{
        Render();
      }
    }
  }

  // ZXbhI
  while(g_PysComputing==1){
    Sleep(100);
  }
  g_PysComputing=3;
  SetEvent(g_hEventPys);
  Sleep(100);

  CleanupUIPanels();
  CleanupBulletWorld();
  DeleteListLMCHand(&g_listLMCHand);
  delete_cube_for_hands();
  destroy_g_listMngTexture();
  destroy_g_listBoneBuf();
  ClearCross();
  ClearPmdxWork(&g_PmdxWork);
  CleanupDX11Device();
  CleanupOVRDevice();

  return ( int )msg.wParam;
}

// OculusRift̏
HRESULT InitOVRDevice(){
  // Initialize "fake" default HMD values for testing without HMD plugged in.
  // These default values match those returned by the HMD.
  g_HMDInfo.HResolution            = 1280;
  g_HMDInfo.VResolution            = 800;
  g_HMDInfo.HScreenSize            = 0.14976f;
  g_HMDInfo.VScreenSize            = g_HMDInfo.HScreenSize / (1280.0f / 800.0f);
  g_HMDInfo.InterpupillaryDistance = 0.064f;
  g_HMDInfo.LensSeparationDistance = 0.0635f;
  g_HMDInfo.EyeToScreenDistance    = 0.041f;
  g_HMDInfo.DistortionK[0]         = 1.0f;
  g_HMDInfo.DistortionK[1]         = 0.22f;
  g_HMDInfo.DistortionK[2]         = 0.24f;
  g_HMDInfo.DistortionK[3]         = 0.0f;

  OVR::System::Init(OVR::Log::ConfigureDefaultLog(OVR::LogMask_All));
  g_pOVRManager = *OVR::DeviceManager::Create();
  g_pHMD = *g_pOVRManager->EnumerateDevices<OVR::HMDDevice>().CreateDevice();
  if(g_pHMD){
    g_pSensor = *g_pHMD->GetSensor();
    if(g_pHMD->GetDeviceInfo(&g_HMDInfo)){
//      g_RendererParams.MonitorName = g_HMDInfo.DisplayDeviceName;
//      g_RendererParams.DisplayId = g_HMDInfo.DisplayId;
    }
  }else{
    g_pSensor = *g_pOVRManager->EnumerateDevices<OVR::SensorDevice>().CreateDevice();
  }

  LPTSTR lpDetectionMessage;
  if((!g_pHMD)||(!g_pSensor)){
    lpDetectionMessage = L"HMD ܂̓ZT[܂";
  }else if(g_HMDInfo.DisplayDeviceName[0] == '\0'){
    lpDetectionMessage = L"HMD  EDID ܂";
  }
  else lpDetectionMessage=nullptr;
  if(lpDetectionMessage){
    MessageBox( nullptr,lpDetectionMessage, L"Error", MB_OK );
    return E_FAIL;
  }
  if (g_HMDInfo.HResolution > 0){
    g_width  = g_HMDInfo.HResolution;
    g_height = g_HMDInfo.VResolution;
  }
  if (g_pSensor){
    g_pSFusion = new OVR::SensorFusion();
    g_pSFusion->AttachToSensor(g_pSensor);
    g_pSFusion->SetPredictionEnabled(true);
  }
  return S_OK;
}

// EBhENX̓o^ƃEBhE̍쐬
HRESULT InitWindow(HINSTANCE hInstance, int nCmdShow ){
  // EBhENX̓o^
  WNDCLASSEX wcex;
  wcex.cbSize = sizeof( WNDCLASSEX );
  wcex.style = CS_OWNDC;
  wcex.lpfnWndProc = WndProc;
  wcex.cbClsExtra = 0;
  wcex.cbWndExtra = 0;
  wcex.hInstance = hInstance;
  wcex.hIcon = (HICON)LoadImage(NULL, IDI_APPLICATION, IMAGE_ICON, 0, 0, LR_SHARED);
  wcex.hCursor = LoadCursor( nullptr, IDC_ARROW );
  wcex.hbrBackground = ( HBRUSH )( COLOR_WINDOW + 1 );
  wcex.lpszMenuName = nullptr;
  wcex.lpszClassName = L"MMTClass";
  wcex.hIconSm = (HICON)LoadImage(NULL, IDI_APPLICATION, IMAGE_ICON, 0, 0, LR_SHARED);
  if( !RegisterClassEx(&wcex )) return E_FAIL;

  // EBhE쐬
  g_hInst = hInstance;
  RECT rc = { 0, 0, g_width, g_height };
  AdjustWindowRect( &rc, WS_POPUP, FALSE );
  g_hWnd = CreateWindow( L"MMTClass", L"MikuMikuTickle", WS_VISIBLE | WS_POPUP,
                         g_HMDInfo.DesktopX, g_HMDInfo.DesktopY,
                         rc.right - rc.left, rc.bottom - rc.top, nullptr, nullptr, hInstance,
                         nullptr );
  if(!g_hWnd) return E_FAIL;

  ShowWindow( g_hWnd, nCmdShow );
  return S_OK;
}

// VF[_t@C̃RpC(`[gÂ̕܂܎gp)
HRESULT CompileShaderFromFile( WCHAR* szFileName, LPCSTR szEntryPoint, LPCSTR szShaderModel, ID3DBlob** ppBlobOut ){
  HRESULT hr = S_OK;

  DWORD dwShaderFlags = D3DCOMPILE_ENABLE_STRICTNESS;
#if defined( DEBUG ) || defined( _DEBUG )
  // Set the D3DCOMPILE_DEBUG flag to embed debug information in the shaders.
  // Setting this flag improves the shader debugging experience, but still allows 
  // the shaders to be optimized and to run exactly the way they will run in 
  // the release configuration of this program.
  dwShaderFlags |= D3DCOMPILE_DEBUG;
#endif

  ID3DBlob* pErrorBlob;
  hr = D3DCompileFromFile( szFileName, nullptr, nullptr, szEntryPoint, szShaderModel, 
                           dwShaderFlags, 0, ppBlobOut, &pErrorBlob );
  if( FAILED(hr) ){
    if( pErrorBlob != nullptr )
      OutputDebugStringA( (char*)pErrorBlob->GetBufferPointer() );
    if( pErrorBlob ) pErrorBlob->Release();
    return hr;
  }
  if( pErrorBlob ) pErrorBlob->Release();

  return S_OK;
}

// DirectX11foCXƃobt@̏
HRESULT InitDX11Device(){
  HRESULT hr = S_OK;

//  RECT rc;
//  GetClientRect( g_hWnd, &rc );
//  g_width = GetSystemMetrics(SM_CXSCREEN); //rc.right - rc.left;
//  g_height = GetSystemMetrics(SM_CYSCREEN); //rc.bottom - rc.top;

  UINT createDeviceFlags = 0;
#ifdef _DEBUG
  createDeviceFlags |= D3D11_CREATE_DEVICE_DEBUG;
#endif

  D3D_DRIVER_TYPE driverTypes[] ={
    D3D_DRIVER_TYPE_HARDWARE,
    D3D_DRIVER_TYPE_WARP,
    D3D_DRIVER_TYPE_REFERENCE,
  };
  UINT numDriverTypes = ARRAYSIZE( driverTypes );

  D3D_FEATURE_LEVEL featureLevels[] ={
    D3D_FEATURE_LEVEL_11_1,
    D3D_FEATURE_LEVEL_11_0,
    D3D_FEATURE_LEVEL_10_1,
    D3D_FEATURE_LEVEL_10_0,
  };
  UINT numFeatureLevels = ARRAYSIZE( featureLevels );

  DXGI_SWAP_CHAIN_DESC sd;
  ZeroMemory( &sd, sizeof( sd ) );
  sd.BufferCount = 1;
  sd.BufferDesc.Width = g_width;
  sd.BufferDesc.Height = g_height;
  sd.BufferDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
  sd.BufferDesc.RefreshRate.Numerator = 60;
  sd.BufferDesc.RefreshRate.Denominator = 1;
  sd.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
  sd.OutputWindow = g_hWnd;
  sd.SampleDesc.Count = 1;
  sd.SampleDesc.Quality = 0;
  sd.Windowed = TRUE;
  sd.Flags = DXGI_SWAP_CHAIN_FLAG_ALLOW_MODE_SWITCH; // tXN[[h𑜓xύX

  for( UINT driverTypeIndex = 0; driverTypeIndex < numDriverTypes; driverTypeIndex++ ){
    g_driverType = driverTypes[driverTypeIndex];
    hr = D3D11CreateDeviceAndSwapChain( nullptr, g_driverType, nullptr, createDeviceFlags, featureLevels, numFeatureLevels,
                                        D3D11_SDK_VERSION, &sd, &g_pSwapChain, &g_pd3dDevice, &g_featureLevel, &g_pImmediateContext );

    if ( hr == E_INVALIDARG ){
      // DirectX 11.0 platforms will not recognize D3D_FEATURE_LEVEL_11_1 so we need to retry without it
      hr = D3D11CreateDeviceAndSwapChain( nullptr, g_driverType, nullptr, createDeviceFlags, &featureLevels[1], numFeatureLevels - 1,
                                          D3D11_SDK_VERSION, &sd, &g_pSwapChain, &g_pd3dDevice, &g_featureLevel, &g_pImmediateContext );
    }

    if(SUCCEEDED(hr)) break;
  }
  if(FAILED(hr)) return hr;

  // tXN[[hɂ
  g_pSwapChain->SetFullscreenState(1, nullptr);

  // Create a render target view
  ID3D11Texture2D* pBackBuffer = nullptr;
  hr = g_pSwapChain->GetBuffer( 0, __uuidof( ID3D11Texture2D ), ( LPVOID* )&pBackBuffer );
  if(FAILED(hr)) return hr;

  hr = g_pd3dDevice->CreateRenderTargetView( pBackBuffer, nullptr, &g_pRenderTargetView );
  pBackBuffer->Release();
  if(FAILED(hr)) return hr;

  // Create depth stencil texture
  D3D11_TEXTURE2D_DESC descDepth;
  ZeroMemory( &descDepth, sizeof(descDepth) );
  descDepth.Width = g_width;
  descDepth.Height = g_height;
  descDepth.MipLevels = 1;
  descDepth.ArraySize = 1;
  descDepth.Format = DXGI_FORMAT_D24_UNORM_S8_UINT;
  descDepth.SampleDesc.Count = 1;
  descDepth.SampleDesc.Quality = 0;
  descDepth.Usage = D3D11_USAGE_DEFAULT;
  descDepth.BindFlags = D3D11_BIND_DEPTH_STENCIL;
  descDepth.CPUAccessFlags = 0;
  descDepth.MiscFlags = 0;
  hr = g_pd3dDevice->CreateTexture2D( &descDepth, nullptr, &g_pDepthStencil );
  if(FAILED(hr)) return hr;

  // Create the depth stencil view
  D3D11_DEPTH_STENCIL_VIEW_DESC descDSV;
  ZeroMemory( &descDSV, sizeof(descDSV) );
  descDSV.Format = descDepth.Format;
  descDSV.ViewDimension = D3D11_DSV_DIMENSION_TEXTURE2D;
  descDSV.Texture2D.MipSlice = 0;
  hr = g_pd3dDevice->CreateDepthStencilView( g_pDepthStencil, &descDSV, &g_pDepthStencilView );
  if(FAILED(hr)) return hr;

  g_pImmediateContext->OMSetRenderTargets( 1, &g_pRenderTargetView, g_pDepthStencilView );

  // Compile the vertex shader
  ID3DBlob* pVSBlob = nullptr;
  hr = CompileShaderFromFile( g_sShaderFile, "vs_main", "vs_4_0", &pVSBlob );
  if( FAILED( hr ) ){
    MessageBox( nullptr,
                L"The vertex shader file cannot be compiled.  Please run this executable from the directory that contains the FX file.", L"Error", MB_OK );
    return hr;
  }

  // Create the vertex shader
  hr = g_pd3dDevice->CreateVertexShader( pVSBlob->GetBufferPointer(), pVSBlob->GetBufferSize(), nullptr, &g_pVertexShader );
  if(FAILED(hr )){
    pVSBlob->Release();
    return hr;
  }

  // Compile the xertex shader for PMD/PMX
  ID3DBlob* pPMDXVSBlob = nullptr;
  hr = CompileShaderFromFile( g_sShaderFile, "pmdx_vs_main", "vs_4_0", &pPMDXVSBlob );
  if( FAILED( hr ) ){
    MessageBox( nullptr,
                L"The vertex shader file cannot be compiled.  Please run this executable from the directory that contains the FX file.", L"Error", MB_OK );
    return hr;
  }

  // Create the vertex shader PMD/PMX
  hr = g_pd3dDevice->CreateVertexShader( pPMDXVSBlob->GetBufferPointer(), pPMDXVSBlob->GetBufferSize(), nullptr, &g_pPMDXVertexShader );
  if(FAILED(hr )){
    pPMDXVSBlob->Release();
    return hr;
  }

  // Define the input layout
  D3D11_INPUT_ELEMENT_DESC layout[] ={
    { "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "NORMAL", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 12, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "TEXCOORD", 0, DXGI_FORMAT_R32G32_FLOAT, 0, 24, D3D11_INPUT_PER_VERTEX_DATA, 0 },
  };
  UINT numElements = ARRAYSIZE( layout );

  // Create the input layout
  hr = g_pd3dDevice->CreateInputLayout( layout, numElements, pVSBlob->GetBufferPointer(),
                                        pVSBlob->GetBufferSize(), &g_pVertexLayout );
  pVSBlob->Release();
  if(FAILED(hr)) return hr;

  // Define the input layout for PMD/PMX
  D3D11_INPUT_ELEMENT_DESC PMDXlayout[] ={
    { "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "NORMAL", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 12, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "TEXCOORD", 0, DXGI_FORMAT_R32G32_FLOAT, 0, 24, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDINDICES", 0, DXGI_FORMAT_R32_UINT, 0, 32, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDINDICES", 1, DXGI_FORMAT_R32_UINT, 0, 36, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDINDICES", 2, DXGI_FORMAT_R32_UINT, 0, 40, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDINDICES", 3, DXGI_FORMAT_R32_UINT, 0, 44, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDWEIGHT", 0, DXGI_FORMAT_R32_FLOAT, 0, 48, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDWEIGHT", 1, DXGI_FORMAT_R32_FLOAT, 0, 52, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDWEIGHT", 2, DXGI_FORMAT_R32_FLOAT, 0, 56, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDWEIGHT", 3, DXGI_FORMAT_R32_FLOAT, 0, 60, D3D11_INPUT_PER_VERTEX_DATA, 0 },
  };
  numElements = ARRAYSIZE( PMDXlayout );

  // Create the input layout for PMD/PMX
  hr = g_pd3dDevice->CreateInputLayout( PMDXlayout, numElements, pPMDXVSBlob->GetBufferPointer(),
                                        pPMDXVSBlob->GetBufferSize(), &g_pPMDXVertexLayout );
  pPMDXVSBlob->Release();
  if(FAILED(hr)) return hr;

  // Compile the pixel shader
  ID3DBlob* pPSBlob = nullptr;
  hr = CompileShaderFromFile( g_sShaderFile, "ps_main", "ps_4_0", &pPSBlob );
  if(FAILED(hr)){
    MessageBox( nullptr,
                L"The pixel shader file cannot be compiled.  Please run this executable from the directory that contains the FX file.", L"Error", MB_OK );
    return hr;
  }

  // Create the pixel shader
  hr = g_pd3dDevice->CreatePixelShader( pPSBlob->GetBufferPointer(), pPSBlob->GetBufferSize(), nullptr, &g_pPixelShader );
  pPSBlob->Release();
  if( FAILED( hr ) ) return hr;

  // Create the constant buffer
  D3D11_BUFFER_DESC bd;
  ZeroMemory( &bd, sizeof(bd) );
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof(ConstantBuffer);
  bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
  bd.CPUAccessFlags = 0;
  hr = g_pd3dDevice->CreateBuffer( &bd, nullptr, &g_pConstantBuffer );
  if(FAILED(hr)) return hr;

  // Tv̐
  D3D11_SAMPLER_DESC samDesc;
  ZeroMemory( &samDesc, sizeof(samDesc) );
  samDesc.Filter = D3D11_FILTER_MIN_MAG_MIP_LINEAR;
  samDesc.AddressU = D3D11_TEXTURE_ADDRESS_WRAP;
  samDesc.AddressV = D3D11_TEXTURE_ADDRESS_WRAP;
  samDesc.AddressW = D3D11_TEXTURE_ADDRESS_WRAP;
  samDesc.MaxAnisotropy = 1;
  samDesc.ComparisonFunc = D3D11_COMPARISON_ALWAYS;
  samDesc.MaxLOD = D3D11_FLOAT32_MAX;

  ID3D11SamplerState *pSamplerState=nullptr;
  hr = g_pd3dDevice->CreateSamplerState( &samDesc, &pSamplerState );
  g_pImmediateContext->PSSetSamplers( 0, 1, &pSamplerState );
  if(pSamplerState) pSamplerState->Release();

  // X^CUXe[g̐(Жʕ\p)
  D3D11_RASTERIZER_DESC ras_desc;
  ras_desc.FillMode=D3D11_FILL_SOLID;
  ras_desc.CullMode=D3D11_CULL_BACK;	//ʃ|S\
  ras_desc.FrontCounterClockwise=FALSE;
  ras_desc.DepthBias=0;
  ras_desc.DepthBiasClamp=0.0f;
  ras_desc.SlopeScaledDepthBias=FALSE;
  ras_desc.DepthClipEnable=FALSE;
  ras_desc.ScissorEnable=FALSE;
  ras_desc.MultisampleEnable=FALSE;
  ras_desc.AntialiasedLineEnable=FALSE;
  hr=g_pd3dDevice->CreateRasterizerState(&ras_desc, &g_pRasterizerStateSingleSide);

  // X^CUXe[g̐(ʕ\p)
  ras_desc.CullMode=D3D11_CULL_NONE;	//ʃ|S\
  hr=g_pd3dDevice->CreateRasterizerState(&ras_desc, &g_pRasterizerStateDoubleSide);

  // X^CUXe[g̐(C[t[p)
  ras_desc.FillMode=D3D11_FILL_WIREFRAME;
  hr=g_pd3dDevice->CreateRasterizerState(&ras_desc, &g_pRasterizerStateWireframe);

  // ufBOXe[g̐
  D3D11_BLEND_DESC blendDesc;
  ZeroMemory( &blendDesc, sizeof( blendDesc ) );
  blendDesc.AlphaToCoverageEnable = FALSE;
  blendDesc.IndependentBlendEnable = FALSE;
  blendDesc.RenderTarget[0].BlendEnable = TRUE;
  blendDesc.RenderTarget[0].SrcBlend = D3D11_BLEND_SRC_ALPHA;
  blendDesc.RenderTarget[0].DestBlend = D3D11_BLEND_INV_SRC_ALPHA;
  blendDesc.RenderTarget[0].BlendOp = D3D11_BLEND_OP_ADD;
  blendDesc.RenderTarget[0].SrcBlendAlpha = D3D11_BLEND_ONE;
  blendDesc.RenderTarget[0].DestBlendAlpha = D3D11_BLEND_ZERO;
  blendDesc.RenderTarget[0].BlendOpAlpha = D3D11_BLEND_OP_ADD;
  blendDesc.RenderTarget[0].RenderTargetWriteMask = D3D11_COLOR_WRITE_ENABLE_ALL;
  g_pd3dDevice->CreateBlendState( &blendDesc, &g_pBlendState );

  // Initialize the world matrix
  g_World = XMMatrixIdentity();

  hr=SetupOVRDistortion();
  if(FAILED(hr)) return hr;

  return S_OK;
}

// Ycݕ␳̏
HRESULT SetupOVRDistortion(){
  HRESULT hr = S_OK;

  // Util_Render_Stereo.cpp
  // StereoConfig::updateDistortionOffsetAndScale() Ql
  // YFovyјcݕ␳Ɏgp[^̈ꕔ߂
  float lensOffset        = g_HMDInfo.LensSeparationDistance * 0.5f;
  float lensShift         = g_HMDInfo.HScreenSize * 0.25f - lensOffset;
  g_lensViewportShift = 4.0f * lensShift / g_HMDInfo.HScreenSize;
  float as = ((FLOAT)g_width/2) / ((FLOAT)g_height);
  float distortionFitX = -1.0f;
  float distortionFitY = 0.0f;
  float dx           = distortionFitX - g_lensViewportShift;
  float dy           = distortionFitY / as;
  float fitRadius    = sqrt(dx * dx + dy * dy);
  float rsq=fitRadius*fitRadius;
  float scale=fitRadius *
              (g_HMDInfo.DistortionK[0] +
               g_HMDInfo.DistortionK[1] * rsq +
               g_HMDInfo.DistortionK[2] * rsq * rsq +
               g_HMDInfo.DistortionK[3] * rsq * rsq * rsq);
  g_distortionScale  = scale/fitRadius;
  float percievedHalfRTDistance = (g_HMDInfo.VScreenSize / 2) * g_distortionScale;
  float YFov = 2.0f * atan(percievedHalfRTDistance/g_HMDInfo.EyeToScreenDistance);
  // Initialize the projection matrix
  XMMATRIX Projection = XMMatrixPerspectiveFovLH( YFov, as, 0.01f, 1000.0f );
  float eyeProjectionShift = g_HMDInfo.HScreenSize * 0.25f - g_HMDInfo.LensSeparationDistance*0.5f;
  float projectionCenterOffset = 4.0f * eyeProjectionShift / g_HMDInfo.HScreenSize;
  XMMATRIX AdjProj;
  AdjProj=XMMatrixTranslation(projectionCenterOffset, 0.0, 0.0);
  g_ProjectionL = XMMatrixMultiply(Projection,AdjProj);
  AdjProj=XMMatrixTranslation(-projectionCenterOffset, 0.0, 0.0);
  g_ProjectionR = XMMatrixMultiply(Projection,AdjProj);

  // ꎟ摜o͗peNX`obt@
  D3D11_TEXTURE2D_DESC descOVRTx;
  ZeroMemory( &descOVRTx, sizeof(descOVRTx) );
  descOVRTx.Width = g_width;
  descOVRTx.Height = g_height;
  descOVRTx.MipLevels = 1;
  descOVRTx.ArraySize = 1;
  descOVRTx.Format = DXGI_FORMAT_R32G32B32A32_FLOAT;
  descOVRTx.SampleDesc.Count = 1;
  descOVRTx.SampleDesc.Quality = 0;
  descOVRTx.Usage = D3D11_USAGE_DEFAULT;
  descOVRTx.BindFlags = D3D11_BIND_SHADER_RESOURCE | D3D11_BIND_RENDER_TARGET;
  descOVRTx.CPUAccessFlags = 0;
  descOVRTx.MiscFlags = 0;
  hr = g_pd3dDevice->CreateTexture2D( &descOVRTx, nullptr, &g_pOVRDistortionTx );
  if(FAILED(hr)) return hr;
  hr = g_pd3dDevice->CreateRenderTargetView( g_pOVRDistortionTx, nullptr, &g_pOVRRenderTargetView );
  if(FAILED(hr)) return hr;
  hr = g_pd3dDevice->CreateShaderResourceView( g_pOVRDistortionTx, nullptr, &g_pOVRShaderResourceView);

  ID3DBlob* pVSBlob = nullptr;
  hr = CompileShaderFromFile( g_sOVRShaderFile, "vs_main", "vs_4_0", &pVSBlob );
  if( FAILED( hr ) ){
    MessageBox( nullptr,
                L"cݕ␳p_VF[_̃RpCɎs܂B", L"Error", MB_OK );
    return hr;
  }
  hr = g_pd3dDevice->CreateVertexShader( pVSBlob->GetBufferPointer(), pVSBlob->GetBufferSize(), nullptr, &g_pOVRVertexShader );
  if(FAILED(hr )){	
    pVSBlob->Release();
    return hr;
  }
  // Define the input layout for OVR Distortion
  D3D11_INPUT_ELEMENT_DESC ovr_layout[] ={
    { "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "TEXCOORD", 0, DXGI_FORMAT_R32G32_FLOAT, 0, 12, D3D11_INPUT_PER_VERTEX_DATA, 0 },
  };
  int numElements = ARRAYSIZE( ovr_layout );

  // Create the input layout for OVR Distortion
  hr = g_pd3dDevice->CreateInputLayout( ovr_layout, numElements, pVSBlob->GetBufferPointer(),
                                        pVSBlob->GetBufferSize(), &g_pOVRVertexLayout );
  pVSBlob->Release();
  if(FAILED(hr)) return hr;

  ID3DBlob* pPSBlob = nullptr;
  hr = CompileShaderFromFile( g_sOVRShaderFile, "ps_main", "ps_4_0", &pPSBlob );
  if(FAILED(hr)){
    MessageBox( nullptr,
                L"cݕ␳psNZVF[_̃RpCɎs܂B", L"Error", MB_OK );
    return hr;
  }
  hr = g_pd3dDevice->CreatePixelShader( pPSBlob->GetBufferPointer(), pPSBlob->GetBufferSize(), nullptr, &g_pOVRPixelShader );
  pPSBlob->Release();
  if( FAILED( hr ) )
        return hr;

  OVRVertex ovr_vertices_L[] ={
    { XMFLOAT3(-1.0f, -1.0f, 0.0f), XMFLOAT2(0.0f, 1.0f) },
    { XMFLOAT3( 0.0f, -1.0f, 0.0f), XMFLOAT2(0.5f, 1.0f) },
    { XMFLOAT3( 0.0f,  1.0f, 0.0f), XMFLOAT2(0.5f, 0.0f) },
    { XMFLOAT3(-1.0f,  1.0f, 0.0f), XMFLOAT2(0.0f, 0.0f) },
  };
  OVRVertex ovr_vertices_R[] ={
    { XMFLOAT3( 0.0f, -1.0f, 0.0f), XMFLOAT2(0.5f, 1.0f) },
    { XMFLOAT3( 1.0f, -1.0f, 0.0f), XMFLOAT2(1.0f, 1.0f) },
    { XMFLOAT3( 1.0f,  1.0f, 0.0f), XMFLOAT2(1.0f, 0.0f) },
    { XMFLOAT3( 0.0f,  1.0f, 0.0f), XMFLOAT2(0.5f, 0.0f) },
  };

  D3D11_BUFFER_DESC bd;
  ZeroMemory( &bd, sizeof(bd) );
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof( ovr_vertices_L );
  bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
  bd.CPUAccessFlags = 0;
  D3D11_SUBRESOURCE_DATA InitData;
  ZeroMemory( &InitData, sizeof(InitData) );
  InitData.pSysMem = ovr_vertices_L;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pOVRVertexBufferL );
  if(FAILED(hr))return hr;
  InitData.pSysMem = ovr_vertices_R;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pOVRVertexBufferR );
  if(FAILED(hr))return hr;

  // Create index buffer for OVR Distortion
  WORD ovr_indices[] ={
    2,1,0,
    0,3,2,
  };
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof( ovr_indices );
  bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
  bd.CPUAccessFlags = 0;
  InitData.pSysMem = ovr_indices;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pOVRIndexBuffer );
  if(FAILED(hr)) return hr;

  // Create the constant buffer for OVR Distortion
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof(OVRConstantBuffer);
  bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
  bd.CPUAccessFlags = 0;
  hr = g_pd3dDevice->CreateBuffer( &bd, nullptr, &g_pOVRConstantBuffer );
  if(FAILED(hr)) return hr;
}

// eNX`t@C̃pX擾(PMDp)
void GetPMDTexturePath(WCHAR *rtnPathTex,WCHAR *rtnPathSph,WCHAR *rtnPathSpa,
                       char *refPath,char *fname){
  int iSrc,iRef,iw,flgPrc;
  char *sPath;
  char wkfname[21];
  char ext[4];
  char sPathTex[_MAX_PATH],sPathSph[_MAX_PATH],sPathSpa[_MAX_PATH];

  sPathTex[0]='\0';
  sPathSph[0]='\0';
  sPathSpa[0]='\0';
  for(iRef=strlen(refPath)-1;iRef>=0;iRef--){
    if(refPath[iRef]=='\\') break;
  }
  iRef++;
  iw=0;
  for(iSrc=0;iSrc<21;iSrc++){
    flgPrc=0;
    if(iSrc==20) flgPrc=1;
    else if((fname[iSrc]=='*')|| /*(fname[iSrc]=='/')||*/ (fname[iSrc]=='\0')) flgPrc=1;
    if(flgPrc){
      sPath=sPathTex;
      if(iw>3){
        ext[0]=tolower(wkfname[iw-3]);
        ext[1]=tolower(wkfname[iw-2]);
        ext[2]=tolower(wkfname[iw-1]);
        ext[3]='\0';
        if(strcmp(ext,"sph")==0){
          sPath=sPathSph;
        }
        else if(strcmp(ext,"spa")==0){
          sPath=sPathSpa;
        }
      }
      wkfname[iw]='\0';
      if(iw>0){
        strncpy(sPath,refPath,iRef);
        strcpy(sPath+iRef,wkfname);
      }
      if(fname[iSrc]=='\0') break;
      iw=0;
    }
    else wkfname[iw++]=fname[iSrc];
  }
  str2wstr(rtnPathTex,sPathTex,_MAX_PATH);
  str2wstr(rtnPathSph,sPathSph,_MAX_PATH);
  str2wstr(rtnPathSpa,sPathSpa,_MAX_PATH);
}

// eNX`t@C̃pX擾(PMXp)
void GetPMXTexturePath(WCHAR *rtnPathTex,t_PmdxWork *pPmdxWork,int texture_index){
  int iRef;
  char refPath[_MAX_PATH];

  rtnPathTex[0]=L'\0';
  if((texture_index>=0)&&(texture_index<((t_pmx_data *)(pPmdxWork->pmdx_data))->texture_count)){
    for(iRef=strlen(pPmdxWork->PmdxPath)-1;iRef>=0;iRef--){
      if(pPmdxWork->PmdxPath[iRef]=='\\') break;
    }
    iRef++;
    strncpy(refPath,pPmdxWork->PmdxPath,iRef);
    refPath[iRef]='\0';
    str2wstr(rtnPathTex,refPath,_MAX_PATH);
    wcscat(rtnPathTex,((t_pmx_data *)(pPmdxWork->pmdx_data))->texture_path[texture_index].aWChar);
  }
}

// {[obt@蓖Ă
void AllocBoneBuf(t_PmdxWork *pPmdxWork){
  HRESULT hr = S_OK;
  BoneBuf *pBoneBuf;
  int nBone,i,bufidx;
  float x0,y0,z0;
  D3D11_BUFFER_DESC bd;

  pBoneBuf=nullptr;
  nBone=GetBoneCount(pPmdxWork);
  if(nBone<MAX_BONE_ARRAY_SIZE){
    for(pBoneBuf=g_listBoneBuf;pBoneBuf;pBoneBuf=pBoneBuf->next){
      if(nBone<=(MAX_BONE_ARRAY_SIZE-pBoneBuf->iUsed)) break;
    }
    if(!pBoneBuf){
      pBoneBuf=new BoneBuf;
      ZeroMemory(pBoneBuf,sizeof(BoneBuf));
      pBoneBuf->next=g_listBoneBuf;
      g_listBoneBuf=pBoneBuf;
      pBoneBuf->iUsed=0;
      pBoneBuf->isUpdated=0;
      ZeroMemory( &bd, sizeof(bd) );
      bd.Usage = D3D11_USAGE_DEFAULT;
      bd.ByteWidth = sizeof(XMFLOAT4X4)*MAX_BONE_ARRAY_SIZE;
      bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
      bd.CPUAccessFlags = 0;
      hr = g_pd3dDevice->CreateBuffer( &bd, nullptr, &(pBoneBuf->pCBuffer) );
    }
    pPmdxWork->iOfsBoneBuf=pBoneBuf->iUsed;
    pBoneBuf->iUsed+=nBone;
    // {[ʒȕ
    for(i=0;i<nBone;i++){
      bufidx=pPmdxWork->iOfsBoneBuf+i;
      GetInitialBonePos(&x0,&y0,&z0,pPmdxWork,i);
      pBoneBuf->amWBone[bufidx].m[3][0]=x0;
      pBoneBuf->amWBone[bufidx].m[3][1]=y0;
      pBoneBuf->amWBone[bufidx].m[3][2]=z0;
    }
  }
  pPmdxWork->pBoneBuf=pBoneBuf;
}

// {[obt@XV
void UpdateBoneBuf(t_PmdxWork *pPmdxWork){
  int nBone,i,bufidx;
  BoneBuf *pBoneBuf;
  float x0,y0,z0;
  XMMATRIX mWork;

  nBone=GetBoneCount(pPmdxWork);
  pBoneBuf=pPmdxWork->pBoneBuf;
  for(i=0;i<nBone;i++){
    if(pPmdxWork->aBoneState[i].flgWValid!=2){
      bufidx=pPmdxWork->iOfsBoneBuf+i;
      x0=pBoneBuf->amWBone[bufidx].m[3][0];
      y0=pBoneBuf->amWBone[bufidx].m[3][1];
      z0=pBoneBuf->amWBone[bufidx].m[3][2];
      mWork=XMLoadFloat4x4(&(pPmdxWork->aBoneState[i].mWBone));
      XMStoreFloat4x4(&(pBoneBuf->amWBone[bufidx]),XMMatrixTranspose(mWork));
      pBoneBuf->amWBone[bufidx].m[3][0]=x0;
      pBoneBuf->amWBone[bufidx].m[3][1]=y0;
      pBoneBuf->amWBone[bufidx].m[3][2]=z0;
      pBoneBuf->isUpdated=1;
    }
  }
}

// {[萔obt@XV
void UpdateAllBoneBufCB(){
  BoneBuf *pBoneBuf;

  for(pBoneBuf=g_listBoneBuf;pBoneBuf;pBoneBuf=pBoneBuf->next){
    if(pBoneBuf->isUpdated){
      g_pImmediateContext->UpdateSubresource(pBoneBuf->pCBuffer,0, nullptr,
                                             pBoneBuf->amWBone,0,0);
      pBoneBuf->isUpdated=0;
    }
  }
}

// eNX`摜̓ǂݍ݂Ɠo^
t_MngTexture *GetTextureAndRegister(WCHAR *wkTexPath){
  TexMetadata metadata;
  DirectX::ScratchImage image;
  t_MngTexture *pMngTexture,*pbMngTexture;
  HRESULT hr = S_OK;
  WIN32_FIND_DATA findData;

  pMngTexture=nullptr;
  if(wcslen(wkTexPath)>0){
    pbMngTexture=nullptr;
    pMngTexture=g_listMngTexture;
    while(pMngTexture){
      if(wcscmp(wkTexPath,pMngTexture->TexPath)==0) break;
      pbMngTexture=pMngTexture;
      pMngTexture=pMngTexture->next;
    }
    if(pMngTexture==nullptr){
      pMngTexture=new t_MngTexture;
      wcscpy(pMngTexture->TexPath,wkTexPath);
      if(FindFirstFile(pMngTexture->TexPath, &findData)==INVALID_HANDLE_VALUE){
        // MessageBox(nullptr, L"݂ȂeNX`t@C", L"Err", MB_OK);
        // MessageBox(nullptr, pMngTexture->TexPath, L"Err", MB_OK);
        pMngTexture->pShaderResourceView=nullptr;
      } else{
        hr = LoadFromWICFile(pMngTexture->TexPath, 0, &metadata, image);
        if(!FAILED(hr)){
          hr = CreateShaderResourceView(g_pd3dDevice, image.GetImages(),
                                        image.GetImageCount(), metadata,
                                        &(pMngTexture->pShaderResourceView));
        }
        if(FAILED(hr)){
          hr = LoadFromTGAFile(pMngTexture->TexPath, &metadata, image);
          if(!FAILED(hr)){
            hr = CreateShaderResourceView(g_pd3dDevice, image.GetImages(),
                                          image.GetImageCount(), metadata,
                                          &(pMngTexture->pShaderResourceView));
          }
        }
        if(FAILED(hr)){
          hr = LoadFromDDSFile(pMngTexture->TexPath, 0, &metadata, image);
          if(!FAILED(hr)){
            hr = CreateShaderResourceView(g_pd3dDevice, image.GetImages(),
                                          image.GetImageCount(), metadata,
                                          &(pMngTexture->pShaderResourceView));
          }
        }
        if(FAILED(hr)){
          MessageBox(nullptr, L"eNX`̓ǂݍ݂Ɏs܂", L"Err", MB_OK);
          pMngTexture->pShaderResourceView=nullptr;
        }
      }
      if(pMngTexture->pShaderResourceView){
        if(pbMngTexture==nullptr) g_listMngTexture=pMngTexture;
        else pbMngTexture->next=pMngTexture;
        pMngTexture->next=nullptr;
      } else{
        delete pMngTexture;
        pMngTexture=nullptr;
      }
      hr = S_OK;
    }
  }
  return pMngTexture;
}

// PMD/PMXfDirectXŕ\邽߂̏
HRESULT SetupPMDXWorkForD3D(t_PmdxWork *pPmdxWork){
  HRESULT hr = S_OK;
  int i,m;
  WCHAR wkTexPath[_MAX_PATH];
  WCHAR wkSphPath[_MAX_PATH];
  WCHAR wkSpaPath[_MAX_PATH];

  // {[obt@̊蓖
  AllocBoneBuf(pPmdxWork);
  // {[Ԃ̏
  SetupBoneStateArray(pPmdxWork);
  if(pPmdxWork->isPMX){
    // [t̏
    if(((t_pmx_data *)(pPmdxWork->pmdx_data))->morph_count>0){
      pPmdxWork->aMorphRate=new float[((t_pmx_data *)(pPmdxWork->pmdx_data))->morph_count];
      for(i=0;i<((t_pmx_data *)(pPmdxWork->pmdx_data))->morph_count;i++)
        pPmdxWork->aMorphRate[i]=0.0f;
    }
    // _Ɨpz̏ƒ_obt@ECfbNXobt@̍쐬
    if(((t_pmx_data *)(pPmdxWork->pmdx_data))->vert_count>0){
      pPmdxWork->aVertex=new PMDXVertex[((t_pmx_data *)(pPmdxWork->pmdx_data))->vert_count];
      // _̃Rs[
      for(i=0;i<((t_pmx_data *)(pPmdxWork->pmdx_data))->vert_count;i++){
        // ({[ό`O)_W̃Rs[
        pPmdxWork->aVertex[i].Pos.x=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].pos.x;
        pPmdxWork->aVertex[i].Pos.y=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].pos.y;
        pPmdxWork->aVertex[i].Pos.z=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].pos.z;
        // @xNg̃Rs[
        pPmdxWork->aVertex[i].Nor.x=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].normal_vec.x;
        pPmdxWork->aVertex[i].Nor.y=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].normal_vec.y;
        pPmdxWork->aVertex[i].Nor.z=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].normal_vec.z;
        // eNX`W̃Rs[
        pPmdxWork->aVertex[i].Tex.x=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].uv.x;
        pPmdxWork->aVertex[i].Tex.y=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].uv.y;
      }
      pPmdxWork->isVertUpdated=1;
      // Create vertex buffer
      D3D11_BUFFER_DESC bd;
      ZeroMemory( &bd, sizeof(bd) );
      bd.Usage = D3D11_USAGE_DEFAULT;
      bd.ByteWidth = sizeof( PMDXVertex ) * (((t_pmx_data *)(pPmdxWork->pmdx_data))->vert_count);
      bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
      bd.CPUAccessFlags = 0;
      D3D11_SUBRESOURCE_DATA InitData;
      ZeroMemory( &InitData, sizeof(InitData) );
      InitData.pSysMem = pPmdxWork->aVertex;
      hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &(pPmdxWork->pVertexBuffer) );
      if(FAILED(hr)){
        MessageBox(nullptr, L"_obt@ł܂ł", L"Err", MB_OK);
      }
      ZeroMemory( &bd, sizeof(bd) );
      bd.Usage = D3D11_USAGE_DEFAULT;
      // PMX̏ꍇ̓CfbNX̃TCY32rbgɂ
      bd.ByteWidth =sizeof(DWORD)*(((t_pmx_data *)(pPmdxWork->pmdx_data))->face_vert_count);
      bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
      bd.CPUAccessFlags = 0;
      ZeroMemory( &InitData, sizeof(InitData) );
      InitData.pSysMem = ((t_pmx_data *)(pPmdxWork->pmdx_data))->face_vert_index;
      hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &(pPmdxWork->pIndexBuffer) );
      if(FAILED(hr)){
        MessageBox(nullptr, L"CfbNXobt@ł܂ł", L"Err", MB_OK);
      }
    }
    if(!FAILED(hr)){
      // eNX`̓ǂݍ
      if(((t_pmx_data *)(pPmdxWork->pmdx_data))->material_count>0){
        pPmdxWork->aMngTexture =
          new t_MngTexture* [((t_pmx_data *)(pPmdxWork->pmdx_data))->material_count];
        pPmdxWork->aMngTexSph =
          new t_MngTexture* [((t_pmx_data *)(pPmdxWork->pmdx_data))->material_count];
        pPmdxWork->aMngTexSpa =
          new t_MngTexture* [((t_pmx_data *)(pPmdxWork->pmdx_data))->material_count];
        for(m=0;m<((t_pmx_data *)(pPmdxWork->pmdx_data))->material_count;m++){
          GetPMXTexturePath(wkTexPath,pPmdxWork,
                            ((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].texture_index);
          pPmdxWork->aMngTexture[m]=GetTextureAndRegister(wkTexPath);
          wkSphPath[0]=L'\0';
          wkSpaPath[0]=L'\0';
          if(((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].sphere_mode==1){
            GetPMXTexturePath(wkSphPath,pPmdxWork,
                              ((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].sphere_index);
          } else if(((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].sphere_mode==2){
            GetPMXTexturePath(wkSpaPath,pPmdxWork,
                              ((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].sphere_index);
          }
          pPmdxWork->aMngTexSph[m]=GetTextureAndRegister(wkSphPath);
          pPmdxWork->aMngTexSpa[m]=GetTextureAndRegister(wkSpaPath);
        }
      }
    }
  }
  else{
    // [t̏
    if(((t_pmd_data *)(pPmdxWork->pmdx_data))->skin_count>0){
      pPmdxWork->aMorphRate=new float[((t_pmd_data *)(pPmdxWork->pmdx_data))->skin_count];
      for(i=0;i<((t_pmd_data *)(pPmdxWork->pmdx_data))->skin_count;i++)
        pPmdxWork->aMorphRate[i]=0.0f;
    }
    // _Ɨpz̏ƒ_obt@̍쐬
    if(((t_pmd_data *)(pPmdxWork->pmdx_data))->vert_count>0){
      pPmdxWork->aVertex=new PMDXVertex[((t_pmd_data *)(pPmdxWork->pmdx_data))->vert_count];
      // _̃Rs[
      for(i=0;i<((t_pmd_data *)(pPmdxWork->pmdx_data))->vert_count;i++){
        // ({[ό`O)_W̃Rs[
        pPmdxWork->aVertex[i].Pos.x=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].pos[0];
        pPmdxWork->aVertex[i].Pos.y=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].pos[1];
        pPmdxWork->aVertex[i].Pos.z=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].pos[2];
        // @xNg̃Rs[
        pPmdxWork->aVertex[i].Nor.x=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].normal_vec[0];
        pPmdxWork->aVertex[i].Nor.y=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].normal_vec[1];
        pPmdxWork->aVertex[i].Nor.z=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].normal_vec[2];
        // eNX`W̃Rs[
        pPmdxWork->aVertex[i].Tex.x=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].uv[0];
        pPmdxWork->aVertex[i].Tex.y=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].uv[1];
      }
      pPmdxWork->isVertUpdated=1;
      // Create vertex buffer
      D3D11_BUFFER_DESC bd;
      ZeroMemory( &bd, sizeof(bd) );
      bd.Usage = D3D11_USAGE_DEFAULT;
      bd.ByteWidth = sizeof( PMDXVertex ) * (((t_pmd_data *)(pPmdxWork->pmdx_data))->vert_count);
      bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
      bd.CPUAccessFlags = 0;
      D3D11_SUBRESOURCE_DATA InitData;
      ZeroMemory( &InitData, sizeof(InitData) );
      InitData.pSysMem = pPmdxWork->aVertex;
      hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &(pPmdxWork->pVertexBuffer) );
      if(FAILED(hr)){
        MessageBox(nullptr, L"_obt@ł܂ł", L"Err", MB_OK);
      }
      ZeroMemory( &bd, sizeof(bd) );
      bd.Usage = D3D11_USAGE_DEFAULT;
      bd.ByteWidth =sizeof(WORD)*(((t_pmd_data *)(pPmdxWork->pmdx_data))->face_vert_count);
      bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
      bd.CPUAccessFlags = 0;
      ZeroMemory( &InitData, sizeof(InitData) );
      InitData.pSysMem = ((t_pmd_data *)(pPmdxWork->pmdx_data))->face_vert_index;
      hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &(pPmdxWork->pIndexBuffer) );
      if(FAILED(hr)){
        MessageBox(nullptr, L"CfbNXobt@ł܂ł", L"Err", MB_OK);
      }
    }
    if(!FAILED(hr)){
      // eNX`̓ǂݍ
      if(((t_pmd_data *)(pPmdxWork->pmdx_data))->material_count>0){
        pPmdxWork->aMngTexture =
          new t_MngTexture* [((t_pmd_data *)(pPmdxWork->pmdx_data))->material_count];
        pPmdxWork->aMngTexSph =
          new t_MngTexture* [((t_pmd_data *)(pPmdxWork->pmdx_data))->material_count];
        pPmdxWork->aMngTexSpa =
          new t_MngTexture* [((t_pmd_data *)(pPmdxWork->pmdx_data))->material_count];
        for(m=0;m<((t_pmd_data *)(pPmdxWork->pmdx_data))->material_count;m++){
          GetPMDTexturePath(wkTexPath,wkSphPath,wkSpaPath,
                            pPmdxWork->PmdxPath,
                            ((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].texture_file_name);
          pPmdxWork->aMngTexture[m]=GetTextureAndRegister(wkTexPath);
          pPmdxWork->aMngTexSph[m]=GetTextureAndRegister(wkSphPath);
          pPmdxWork->aMngTexSpa[m]=GetTextureAndRegister(wkSpaPath);
        }
      }
    }
  }
  SetVertDeformInf(pPmdxWork);
  SetupPMDXBullet(pPmdxWork);
  Setup_amRbBoneConv(pPmdxWork);
  return hr;
}

// ȈՃnh`
void setup_cube_for_hands(){
  HRESULT hr = S_OK;

  SimpleVertex vertices[] ={
    { XMFLOAT3( -1.0f, 1.0f, -1.0f ), XMFLOAT3( -1.0f, 1.0f, -1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( 1.0f, 1.0f, -1.0f ), XMFLOAT3( 1.0f, 1.0f, -1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( 1.0f, 1.0f, 1.0f ), XMFLOAT3( 1.0f, 1.0f, 1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( -1.0f, 1.0f, 1.0f ), XMFLOAT3( -1.0f, 1.0f, 1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( -1.0f, -1.0f, -1.0f ), XMFLOAT3( -1.0f, -1.0f, -1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( 1.0f, -1.0f, -1.0f ), XMFLOAT3( 1.0f, -1.0f, -1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( 1.0f, -1.0f, 1.0f ), XMFLOAT3( 1.0f, -1.0f, 1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( -1.0f, -1.0f, 1.0f ), XMFLOAT3( -1.0f, -1.0f, 1.0f ), XMFLOAT2( 0.0f, 0.0f) },
  };

  D3D11_BUFFER_DESC bd;
  ZeroMemory( &bd, sizeof(bd) );
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof( vertices );
  bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
  bd.CPUAccessFlags = 0;
  D3D11_SUBRESOURCE_DATA InitData;
  ZeroMemory( &InitData, sizeof(InitData) );
  InitData.pSysMem = vertices;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pVertexBufferCube );

  WORD indices[] ={
    3,1,0,
    2,1,3,

    0,5,4,
    1,5,0,

    3,4,7,
    0,4,3,

    1,6,5,
    2,6,1,

    2,7,6,
    3,7,2,

    6,4,5,
    7,4,6,
  };

  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof( indices );
  bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
  bd.CPUAccessFlags = 0;
  InitData.pSysMem = indices;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pIndexBufferCube );
};

void SetCrossCube(int ipt,XMMATRIX *mWork,XMFLOAT3 *fvpos,WORD *qb_indices,
                  SimpleVertex *vertices,WORD *indices){
  XMVECTOR vWk1,vWk2,vWk3;
  int ivr,ivs,iir,iis,i;

  // _W
  for(ivs=0;ivs<24;ivs++){
    ivr=24*ipt+ivs;
    vWk1=XMLoadFloat3(&(fvpos[qb_indices[ivs]]));
    vWk2=XMVector3Transform(vWk1,*mWork);
    XMStoreFloat3(&(vertices[ivr].Pos),vWk2);
    vertices[ivr].Tex.x=0.0f;
    vertices[ivr].Tex.y=0.0f;
  }
  // @xNg
  for(ivs=0;ivs<24;ivs+=4){
    ivr=24*ipt+ivs;
    vWk1=(XMLoadFloat3(&(vertices[ivr+1].Pos))-XMLoadFloat3(&(vertices[ivr].Pos)));
    vWk2=(XMLoadFloat3(&(vertices[ivr+2].Pos))-XMLoadFloat3(&(vertices[ivr].Pos)));
    vWk3=XMVector3Normalize(XMVector3Cross(vWk1,vWk2));
    for(i=0;i<4;i++){
      XMStoreFloat3(&(vertices[ivr+i].Nor),vWk3);
    }
  }
  // CfbNX
  iir=36*ipt;
  for(iis=0;iis<24;iis+=4){
    ivr=24*ipt+iis;
    indices[iir]=ivr;
    indices[iir+1]=ivr+2;
    indices[iir+2]=ivr+3;
    indices[iir+3]=ivr+1;
    indices[iir+4]=ivr+2;
    indices[iir+5]=ivr+0;
    iir+=6;
  }
}

void SetExcludeGive(t_PmdxWork *pPmdxWork){
  pPmdxWork->nBoneExcludeGive=13;
  pPmdxWork->aiBoneExcludeGive=new int[pPmdxWork->nBoneExcludeGive];
  pPmdxWork->aiBoneExcludeGive[0]=search_bone_idx(pPmdxWork,"㔼g");
  pPmdxWork->aiBoneExcludeGive[1]=search_bone_idx(pPmdxWork,"㔼g2");
  pPmdxWork->aiBoneExcludeGive[2]=search_bone_idx(pPmdxWork,"");
  pPmdxWork->aiBoneExcludeGive[3]=search_bone_idx(pPmdxWork,"r");
  pPmdxWork->aiBoneExcludeGive[4]=search_bone_idx(pPmdxWork,"Ђ");
  pPmdxWork->aiBoneExcludeGive[5]=search_bone_idx(pPmdxWork,"");
  pPmdxWork->aiBoneExcludeGive[6]=search_bone_idx(pPmdxWork,"Ђ");
  pPmdxWork->aiBoneExcludeGive[7]=search_bone_idx(pPmdxWork,"");
  pPmdxWork->aiBoneExcludeGive[8]=search_bone_idx(pPmdxWork,"E");
  pPmdxWork->aiBoneExcludeGive[9]=search_bone_idx(pPmdxWork,"Er");
  pPmdxWork->aiBoneExcludeGive[10]=search_bone_idx(pPmdxWork,"EЂ");
  pPmdxWork->aiBoneExcludeGive[11]=search_bone_idx(pPmdxWork,"E");
  pPmdxWork->aiBoneExcludeGive[12]=search_bone_idx(pPmdxWork,"EЂ");
  pPmdxWork->aiBoneExcludeGive[13]=search_bone_idx(pPmdxWork,"E");
}

// PMD/PMXfɂ
void CrucifyModel(t_PmdxWork *pPmdxWork,int flgInit){
  HRESULT hr = S_OK;
  XMMATRIX mBone,mWork;
  int iBone;
  float chxR,chxL,chy;
  XMVECTOR vWk1;

  static XMFLOAT3 fvpos[] ={
    XMFLOAT3( -1.0f, 1.0f, -1.0f ),
    XMFLOAT3( 1.0f, 1.0f, -1.0f ),
    XMFLOAT3( 1.0f, 1.0f, 1.0f ),
    XMFLOAT3( -1.0f, 1.0f, 1.0f ),
    XMFLOAT3( -1.0f, -1.0f, -1.0f ),
    XMFLOAT3( 1.0f, -1.0f, -1.0f ),
    XMFLOAT3( 1.0f, -1.0f, 1.0f ),
    XMFLOAT3( -1.0f, -1.0f, 1.0f ),
  };

  static WORD qb_indices[] ={ // 14_
    3,2,1,0,
    0,1,5,4,
    3,0,4,7,
    1,2,6,5,
    2,3,7,6,
    6,7,4,5,
  };

  if(flgInit){
    //Eグ
    mBone=XMMatrixRotationZ(-40.0f*XM_PI/180.0f);
    iBone=search_bone_idx(pPmdxWork,"E");
    if(iBone>=0){
      mBone.r[3]=XMVectorSet(pPmdxWork->aBoneState[iBone].mLBone.m[3][0],
                             pPmdxWork->aBoneState[iBone].mLBone.m[3][1],
                             pPmdxWork->aBoneState[iBone].mLBone.m[3][2],
                             pPmdxWork->aBoneState[iBone].mLBone.m[3][3]);
      UpdateLBone(pPmdxWork,iBone,&mBone);
      iBone=search_bone_idx(pPmdxWork,"Er");
      if(iBone>=0){
        mBone.r[3]=XMVectorSet(pPmdxWork->aBoneState[iBone].mLBone.m[3][0],
                               pPmdxWork->aBoneState[iBone].mLBone.m[3][1],
                               pPmdxWork->aBoneState[iBone].mLBone.m[3][2],
                               pPmdxWork->aBoneState[iBone].mLBone.m[3][3]);
        UpdateLBone(pPmdxWork,iBone,&mBone);
      }
    } else{
      mBone=XMMatrixRotationZ(-80.0f*XM_PI/180.0f);
      iBone=search_bone_idx(pPmdxWork,"Er");
      if(iBone>=0){
        mBone.r[3]=XMVectorSet(pPmdxWork->aBoneState[iBone].mLBone.m[3][0],
                               pPmdxWork->aBoneState[iBone].mLBone.m[3][1],
                               pPmdxWork->aBoneState[iBone].mLBone.m[3][2],
                               pPmdxWork->aBoneState[iBone].mLBone.m[3][3]);
        UpdateLBone(pPmdxWork,iBone,&mBone);
      }
    }

    //グ
    mBone=XMMatrixRotationZ(40.0f*XM_PI/180.0f);
    iBone=search_bone_idx(pPmdxWork,"");
    if(iBone>=0){
      mBone.r[3]=XMVectorSet(pPmdxWork->aBoneState[iBone].mLBone.m[3][0],
                             pPmdxWork->aBoneState[iBone].mLBone.m[3][1],
                             pPmdxWork->aBoneState[iBone].mLBone.m[3][2],
                             pPmdxWork->aBoneState[iBone].mLBone.m[3][3]);
      UpdateLBone(pPmdxWork,iBone,&mBone);
      iBone=search_bone_idx(pPmdxWork,"r");
      if(iBone>=0){
        mBone.r[3]=XMVectorSet(pPmdxWork->aBoneState[iBone].mLBone.m[3][0],
                               pPmdxWork->aBoneState[iBone].mLBone.m[3][1],
                               pPmdxWork->aBoneState[iBone].mLBone.m[3][2],
                               pPmdxWork->aBoneState[iBone].mLBone.m[3][3]);
        UpdateLBone(pPmdxWork,iBone,&mBone);
      }
    } else{
      mBone=XMMatrixRotationZ(80.0f*XM_PI/180.0f);
      iBone=search_bone_idx(pPmdxWork,"r");
      if(iBone>=0){
        mBone.r[3]=XMVectorSet(pPmdxWork->aBoneState[iBone].mLBone.m[3][0],
                               pPmdxWork->aBoneState[iBone].mLBone.m[3][1],
                               pPmdxWork->aBoneState[iBone].mLBone.m[3][2],
                               pPmdxWork->aBoneState[iBone].mLBone.m[3][3]);
        UpdateLBone(pPmdxWork,iBone,&mBone);
      }
    }

    // ]t^𔽉f
    SetExcludeGive(pPmdxWork);
    GiveRotate(pPmdxWork);
    // [hsXV
    ValidateAllWBone(pPmdxWork);

    // g̈ʒu߂
    chxR=(-5.0f); // 
    chxL=5.0f; // 
    chy=15.0f; // 
    iBone=search_bone_idx(pPmdxWork,"EЂ");
    if(iBone>=0){
      chxR=pPmdxWork->aBoneState[iBone].mWBone.m[3][0];
      chy=pPmdxWork->aBoneState[iBone].mWBone.m[3][1];
    }
    iBone=search_bone_idx(pPmdxWork,"Ђ");
    if(iBone>=0){
      chxL=pPmdxWork->aBoneState[iBone].mWBone.m[3][0];
    }

    // ό`̂őgݗĂ
    // x[X
    mWork=XMMatrixScaling(20.0f,1.0f,15.0f)*XMMatrixTranslation(0.0f,-5.0f,0.0f);
    SetCrossCube(0,&mWork,fvpos,qb_indices,g_CrossVertices,g_CrossIndices);
    // Β1
    mWork=XMMatrixScaling(0.7f,chy/2.0f,1.0f)*XMMatrixTranslation(0.0f,chy/2.0f-1.0f,0.0f)*
      XMMatrixRotationZ(-45.0f*XM_PI/180.0f)*XMMatrixTranslation(chxL,chy,3.0f);
    SetCrossCube(1,&mWork,fvpos,qb_indices,g_CrossVertices,g_CrossIndices);
    // c1
    vWk1=XMVectorSet(-1.0f, 1.0f, 0.0f, 0.0f);
    vWk1=XMVector3Transform(vWk1,mWork);
    mWork=XMMatrixTranslation(0.0f,-1.0f,0.0f)*
      XMMatrixScaling(1.0f,(XMVectorGetY(vWk1)+4.0f)/2.0f,1.0f)*
        XMMatrixTranslation(XMVectorGetX(vWk1)+1.0f,XMVectorGetY(vWk1),3.0f);
    SetCrossCube(2,&mWork,fvpos,qb_indices,g_CrossVertices,g_CrossIndices);
    // Β2
    mWork=XMMatrixScaling(0.7f,chy/2.0f,1.0f)*XMMatrixTranslation(0.0f,chy/2.0f-1.0f,0.0f)*
      XMMatrixRotationZ(45.0f*XM_PI/180.0f)*XMMatrixTranslation(chxR,chy,3.0f);
    SetCrossCube(3,&mWork,fvpos,qb_indices,g_CrossVertices,g_CrossIndices);
    // c2
    vWk1=XMVectorSet(1.0f, 1.0f, 0.0f, 0.0f);
    vWk1=XMVector3Transform(vWk1,mWork);
    mWork=XMMatrixTranslation(0.0f,-1.0f,0.0f)*
      XMMatrixScaling(1.0f,(XMVectorGetY(vWk1)+4.0f)/2.0f,1.0f)*
        XMMatrixTranslation(XMVectorGetX(vWk1)-1.0f,XMVectorGetY(vWk1),3.0f);
    SetCrossCube(4,&mWork,fvpos,qb_indices,g_CrossVertices,g_CrossIndices);
    // Eg
    mWork=XMMatrixScaling(0.7f,1.0f,2.0f)*
      XMMatrixRotationZ(45.0f*XM_PI/180.0f)*
        XMMatrixTranslation(chxR,chy,1.0f);
    SetCrossCube(5,&mWork,fvpos,qb_indices,g_CrossVertices,g_CrossIndices);
    // g
    mWork=XMMatrixScaling(0.7f,1.0f,2.0f)*
      XMMatrixRotationZ(-45.0f*XM_PI/180.0f)*
        XMMatrixTranslation(chxL,chy,1.0f);
    SetCrossCube(6,&mWork,fvpos,qb_indices,g_CrossVertices,g_CrossIndices);
    // 𓮂߂̐ݒ
    g_ft_shackle_L_pos=XMFLOAT3(2.0f,2.0f,0.0f); // 
    g_leg_L_pos=XMFLOAT3(2.0f,10.0f,0.0f); // 
    g_ankle_L_pos=XMFLOAT3(2.0f,1.0f,0.0f); // 
    iBone=g_bone_idx_ankle_L;
    if((iBone>=0)&&(g_bone_idx_leg_L>=0)){
      g_ft_shackle_L_pos=XMFLOAT3(max(g_PmdxWork.aBoneState[iBone].mWBone.m[3][0],1.0f),
                                  g_PmdxWork.aBoneState[iBone].mWBone.m[3][1]+1.0f,
                                  g_PmdxWork.aBoneState[iBone].mWBone.m[3][2]);
      g_ankle_L_pos=XMFLOAT3(g_PmdxWork.aBoneState[iBone].mWBone.m[3][0],
                             g_PmdxWork.aBoneState[iBone].mWBone.m[3][1],
                             g_PmdxWork.aBoneState[iBone].mWBone.m[3][2]);
      g_leg_L_pos=XMFLOAT3(g_PmdxWork.aBoneState[g_bone_idx_leg_L].mWBone.m[3][0],
                           g_PmdxWork.aBoneState[g_bone_idx_leg_L].mWBone.m[3][1],
                           g_PmdxWork.aBoneState[g_bone_idx_leg_L].mWBone.m[3][2]);
    }
    iBone=g_bone_idx_knee_L;
    if(iBone>=0){
      g_knee_L_pos=XMFLOAT3(g_PmdxWork.aBoneState[iBone].mWBone.m[3][0],
                            g_PmdxWork.aBoneState[iBone].mWBone.m[3][1],
                            g_PmdxWork.aBoneState[iBone].mWBone.m[3][2]);
    }
    g_ft_shackle_R_pos=XMFLOAT3(-2.0f,2.0f,0.0f); // 
    g_leg_R_pos=XMFLOAT3(-2.0f,10.0f,0.0f); // 
    g_ankle_R_pos=XMFLOAT3(-2.0f,1.0f,0.0f); // 
    iBone=g_bone_idx_ankle_R;
    if((iBone>=0)&&(g_bone_idx_leg_R>=0)){
      g_ft_shackle_R_pos=XMFLOAT3(min(g_PmdxWork.aBoneState[iBone].mWBone.m[3][0],-1.0f),
                                  g_PmdxWork.aBoneState[iBone].mWBone.m[3][1]+1.0f,
                                  g_PmdxWork.aBoneState[iBone].mWBone.m[3][2]);
      g_ankle_R_pos=XMFLOAT3(g_PmdxWork.aBoneState[iBone].mWBone.m[3][0],
                             g_PmdxWork.aBoneState[iBone].mWBone.m[3][1],
                             g_PmdxWork.aBoneState[iBone].mWBone.m[3][2]);
      g_leg_R_pos=XMFLOAT3(g_PmdxWork.aBoneState[g_bone_idx_leg_R].mWBone.m[3][0],
                           g_PmdxWork.aBoneState[g_bone_idx_leg_R].mWBone.m[3][1],
                           g_PmdxWork.aBoneState[g_bone_idx_leg_R].mWBone.m[3][2]);
    }
    iBone=g_bone_idx_knee_R;
    if(iBone>=0){
      g_knee_R_pos=XMFLOAT3(g_PmdxWork.aBoneState[iBone].mWBone.m[3][0],
                            g_PmdxWork.aBoneState[iBone].mWBone.m[3][1],
                            g_PmdxWork.aBoneState[iBone].mWBone.m[3][2]);
    }
  }
  // ݒ肷
  // g
  mWork=XMMatrixTranslation(g_ft_shackle_L_pos.x-g_leg_L_pos.x,g_ft_shackle_L_pos.y-g_leg_L_pos.y,
                            g_ft_shackle_L_pos.z-g_leg_L_pos.z)*
    XMMatrixRotationZ(g_leg_open_angle)*XMMatrixRotationX(g_leg_front_angle)*
      XMMatrixTranslation(g_leg_L_pos.x,g_leg_L_pos.y,g_leg_L_pos.z);
  SetCrossCube(7,&mWork,fvpos,qb_indices,g_CrossVertices,g_CrossIndices);
  // gx
  vWk1=XMVectorSet(0.0f,0.0f,1.2f,0.0f);
  vWk1=XMVector3Transform(vWk1,mWork);
  mWork=XMMatrixTranslation(0.0f,-1.0f,0.0f)*
    XMMatrixScaling(0.2f, (XMVectorGetY(vWk1)+4.2f)/2.0f, 0.2f)*
      XMMatrixTranslation(XMVectorGetX(vWk1),XMVectorGetY(vWk1)+0.2f,XMVectorGetZ(vWk1));
  SetCrossCube(8,&mWork,fvpos,qb_indices,g_CrossVertices,g_CrossIndices);
  // Eg
  mWork=XMMatrixTranslation(g_ft_shackle_R_pos.x-g_leg_R_pos.x,g_ft_shackle_R_pos.y-g_leg_R_pos.y,
                            g_ft_shackle_R_pos.z-g_leg_R_pos.z)*
    XMMatrixRotationZ(-g_leg_open_angle)*XMMatrixRotationX(g_leg_front_angle)*
      XMMatrixTranslation(g_leg_R_pos.x,g_leg_R_pos.y,g_leg_R_pos.z);
  SetCrossCube(9,&mWork,fvpos,qb_indices,g_CrossVertices,g_CrossIndices);
  // Egx
  vWk1=XMVectorSet(0.0f,0.0f,1.2f,0.0f);
  vWk1=XMVector3Transform(vWk1,mWork);
  mWork=XMMatrixTranslation(0.0f,-1.0f,0.0f)*
    XMMatrixScaling(0.2f, (XMVectorGetY(vWk1)+4.2f)/2.0f, 0.2f)*
      XMMatrixTranslation(XMVectorGetX(vWk1),XMVectorGetY(vWk1)+0.2f,XMVectorGetZ(vWk1));
  SetCrossCube(10,&mWork,fvpos,qb_indices,g_CrossVertices,g_CrossIndices);

  if(flgInit){
    // _obt@쐬
    D3D11_BUFFER_DESC bd;
    ZeroMemory( &bd, sizeof(bd) );
    bd.Usage = D3D11_USAGE_DEFAULT;
    bd.ByteWidth = sizeof( g_CrossVertices );
    bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
    bd.CPUAccessFlags = 0;
    D3D11_SUBRESOURCE_DATA InitData;
    ZeroMemory( &InitData, sizeof(InitData) );
    InitData.pSysMem = g_CrossVertices;
    hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pVertexBufferCross );
    // CfbNXobt@쐬
    bd.Usage = D3D11_USAGE_DEFAULT;
    bd.ByteWidth = sizeof( g_CrossIndices );
    bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
    bd.CPUAccessFlags = 0;
    InitData.pSysMem = g_CrossIndices;
    hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pIndexBufferCross );
  }
  else{
    // _obt@XV
    g_pImmediateContext->UpdateSubresource( g_pVertexBufferCross, 0, nullptr,
                                            g_CrossVertices, 0, 0 );
  }
}

void GetMatrixLUBody(t_PmdxWork *pPmdxWork,XMMATRIX *mLUBody){
  XMVECTOR vShoulderL=XMLoadFloat3(&(pPmdxWork->aSimBodyNode[2].vPosNow));
  XMVECTOR vShoulderR=XMLoadFloat3(&(pPmdxWork->aSimBodyNode[8].vPosNow));
  XMVECTOR vLegL=XMLoadFloat3(&(pPmdxWork->aSimBodyNode[5].vPosNow));
  XMVECTOR vLegR=XMLoadFloat3(&(pPmdxWork->aSimBodyNode[11].vPosNow));
  XMVECTOR vPosShoulderM=(vShoulderL+vShoulderR)/2.0f;
  mLUBody->r[0]=XMVector3Normalize(vLegL-vLegR);
  mLUBody->r[2]=XMVector3Normalize(XMVector3Cross(mLUBody->r[0],vPosShoulderM-vLegR));
  mLUBody->r[1]=XMVector3Cross(mLUBody->r[2],mLUBody->r[0]);
  mLUBody->r[3]=vLegR;
  mLUBody->r[0]=XMVectorSetW(mLUBody->r[0],0.0f);
  mLUBody->r[1]=XMVectorSetW(mLUBody->r[1],0.0f);
  mLUBody->r[2]=XMVectorSetW(mLUBody->r[2],0.0f);
  mLUBody->r[3]=XMVectorSetW(mLUBody->r[3],1.0f);
}

// g̋V~[V̏
int SetupSimBody(t_PmdxWork *pPmdxWork){
  int success=1;
  AllocSimBody(pPmdxWork,14,15,11);
  if((g_bone_idx_ubody=SetBodyNodeByBoneName(pPmdxWork,0,"㔼g",1))<0) success=0;
  g_bone_idx_ubody2=SetBodyNodeByBoneName(pPmdxWork,1,"㔼g2",1);
  if(SetBodyNodeByBoneName(pPmdxWork,2,"",1)<0) success=0;
  if((g_bone_idx_arm_L=SetBodyNodeByBoneName(pPmdxWork,3,"r",1))<0) success=0;
  if(SetBodyNodeByBoneName(pPmdxWork,4,"Ђ",0)<0) success=0;
  if(SetBodyNodeByBoneName(pPmdxWork,5,"",1)<0) success=0;
  if(SetBodyNodeByBoneName(pPmdxWork,6,"Ђ",1)<0) success=0;
  if(SetBodyNodeByBoneName(pPmdxWork,7,"",0)<0) success=0;
  if(SetBodyNodeByBoneName(pPmdxWork,8,"E",1)<0) success=0;
  if((g_bone_idx_arm_R=SetBodyNodeByBoneName(pPmdxWork,9,"Er",1))<0) success=0;
  if(SetBodyNodeByBoneName(pPmdxWork,10,"EЂ",0)<0) success=0;
  if(SetBodyNodeByBoneName(pPmdxWork,11,"E",1)<0) success=0;
  if(SetBodyNodeByBoneName(pPmdxWork,12,"EЂ",1)<0) success=0;
  if(SetBodyNodeByBoneName(pPmdxWork,13,"E",0)<0) success=0;
  if(g_bone_idx_ubody2>=0){
    SetBodyWire(pPmdxWork,0,0,1);
    SetBodyWire(pPmdxWork,1,1,2);
    SetBodyWire(pPmdxWork,2,1,8);
  } else{
    SetBodyWire(pPmdxWork,1,0,2);
    SetBodyWire(pPmdxWork,2,0,8);
  }
  SetBodyWire(pPmdxWork,3,2,8);
  SetBodyWire(pPmdxWork,4,0,5);
  SetBodyWire(pPmdxWork,5,0,11);
  SetBodyWire(pPmdxWork,6,5,11);
  SetBodyWire(pPmdxWork,7,2,3);
  SetBodyWire(pPmdxWork,8,3,4);
  SetBodyWire(pPmdxWork,9,5,6);
  SetBodyWire(pPmdxWork,10,6,7);
  SetBodyWire(pPmdxWork,11,8,9);
  SetBodyWire(pPmdxWork,12,9,10);
  SetBodyWire(pPmdxWork,13,11,12);
  SetBodyWire(pPmdxWork,14,12,13);
  if((g_bone_idx_lbody=SetSimBody2Bone(pPmdxWork,0,0,5,11,""))<0)
    g_bone_idx_lbody=SetSimBody2Bone(pPmdxWork,0,0,5,11,"g");
  if(g_bone_idx_ubody2>=0){
    SetSimBody2Bone(pPmdxWork,1,0,1,-1,"㔼g");
    SetSimBody2Bone(pPmdxWork,2,1,2,8,"㔼g2");
  } else{
    SetSimBody2Bone(pPmdxWork,1,0,2,8,"㔼g");
  }
  SetSimBody2Bone(pPmdxWork,3,2,3,-1,"");
  SetSimBody2Bone(pPmdxWork,4,3,4,-1,"r");
  SetSimBody2Bone(pPmdxWork,5,5,6,-1,"");
  SetSimBody2Bone(pPmdxWork,6,6,7,-1,"Ђ");
  SetSimBody2Bone(pPmdxWork,7,8,9,-1,"E");
  SetSimBody2Bone(pPmdxWork,8,9,10,-1,"Er");
  SetSimBody2Bone(pPmdxWork,9,11,12,-1,"E");
  SetSimBody2Bone(pPmdxWork,10,12,13,-1,"EЂ");
  if(success){
    BuildSimBody(pPmdxWork);
    XMMATRIX mLUBody;
    GetMatrixLUBody(pPmdxWork,&mLUBody);
    XMVECTOR vDet;
    XMMATRIX mLUBodyInv=XMMatrixInverse(&vDet,mLUBody);
    XMStoreFloat4x4(&g_mLUBodyInv,mLUBodyInv);
    g_ubody_pos=pPmdxWork->aSimBodyNode[0].vPosNow;
    g_ubody2_pos=pPmdxWork->aSimBodyNode[1].vPosNow;
    float fshoulder_y=pPmdxWork->aSimBodyNode[2].vPosNow.y;
    g_ubody_breath_z=(fshoulder_y-g_ubody_pos.y)*sin(5.0f*XM_PI/180.0f);
    g_ubody2_breath_z=g_ubody_breath_z;
  }
  if(g_bone_idx_arm_L>=0) g_arm_L_pos=pPmdxWork->aSimBodyNode[3].vPosNow;
  if(g_bone_idx_arm_R>=0) g_arm_R_pos=pPmdxWork->aSimBodyNode[9].vPosNow;
  return success;
}

// ẘȈՃnhݒ肷
void SetTklHand(int iTklHand,t_PmdxWork *pPmdxWork,int iBone, int isRight,
                   float sx,float sy,float sz,float rx,float ry,float rz,
                   float px,float py,float pz){
  g_aTklHand[iTklHand].isRight=isRight;
  g_aTklHand[iTklHand].pPmdxWork=pPmdxWork;
  g_aTklHand[iTklHand].iBone=iBone;
  XMMATRIX mLocal=XMMatrixScaling(sx,sy,sz)*
    XMMatrixRotationX(rx)*XMMatrixRotationY(ry)*XMMatrixRotationZ(rz)*
      XMMatrixTranslation(px,py,pz);
  if(pPmdxWork && (iBone>=0)){
    XMMATRIX mWBone=XMLoadFloat4x4(&(pPmdxWork->aBoneState[iBone].mWBone));
    XMVECTOR vDet;
    XMMATRIX mWBoneInv=XMMatrixInverse(&vDet,mWBone);
    mLocal*=mWBoneInv;
  }
  XMStoreFloat4x4(&(g_aTklHand[iTklHand].mLocal),mLocal);
  g_aTklHand[iTklHand].mWorld=g_aTklHand[iTklHand].mLocal; // {[Ȃ̏ꍇׂ̈̃ftHg
}

// ȈՃnhݒ肷
void SetupTklHand(t_PmdxWork *pPmdxWork){
  int i,i_bone_arm_r,i_bone_ubody,i_bone_ubody2,iBone;
  int i_bone_idx_ankle,i_bone_idx_toe_IK;
  float wx1,wy1,wz1,wx2,wy2,wz2;
  float px,py,pz,sz,sa;

  // ғtO
  for(i=0;i<NUM_OF_TKLHAND;i++) g_tkl_hand_active[i]=0;
  //
  // {[Ȃ̉ʒu
  px=-5.0f;
  py=10.0f;
  pz=0.0f;
  // ڈƂȂ{[T
  i_bone_arm_r=search_bone_idx(pPmdxWork,"Er");
  i_bone_ubody=search_bone_idx(pPmdxWork,"㔼g");
  // {[|Ɉʒuݒ
  if(i_bone_arm_r>=0){
    GetInitialBonePos(&wx1,&wy1,&wz1,pPmdxWork,i_bone_arm_r);
    px=wx1-0.2f;
    if(i_bone_ubody>=0){
      GetInitialBonePos(&wx1,&wy1,&wz1,pPmdxWork,i_bone_ubody);
      GetInitialBonePos(&wx2,&wy2,&wz2,pPmdxWork,i_bone_arm_r);
      py=(wy1+wy2)/2.0f;
    }
  }
  if(i_bone_ubody>=0){
    GetInitialBonePos(&wx1,&wy1,&wz1,pPmdxWork,i_bone_ubody);
    pz=wz1;
  }
  i_bone_ubody2=search_bone_idx(pPmdxWork,"㔼g2");
  if(i_bone_ubody2>=0) iBone=i_bone_ubody2;
  else iBone=i_bone_ubody;
  SetTklHand(0,&g_PmdxWork,iBone, 0, 1.0f,1.0f,1.0f, 0.0f,0.0f,0.0f, px,py,pz);
  SetTklHand(1,&g_PmdxWork,iBone, 1, 1.0f,1.0f,1.0f, 0.0f,0.0f,0.0f, -px,py,pz);

  //
  for(int i=0;i<2;i++){
    if(i==0){ // 
      i_bone_idx_ankle=g_bone_idx_ankle_L;
      i_bone_idx_toe_IK=search_bone_idx(pPmdxWork,"ܐhj");
      sa=1;
    } else{ // E
      i_bone_idx_ankle=g_bone_idx_ankle_R;
      i_bone_idx_toe_IK=search_bone_idx(pPmdxWork,"Eܐhj");
      sa=(-1);
    }
    if((i_bone_idx_ankle>=0)&&(i_bone_idx_toe_IK)){
      px=g_PmdxWork.aBoneState[i_bone_idx_ankle].mWBone.m[3][0];
      py=g_PmdxWork.aBoneState[i_bone_idx_toe_IK].mWBone.m[3][1]-0.2f;
      sz=fabs(g_PmdxWork.aBoneState[i_bone_idx_ankle].mWBone.m[3][2]-
              g_PmdxWork.aBoneState[i_bone_idx_toe_IK].mWBone.m[3][2])*1.3/2.0f;
      pz=g_PmdxWork.aBoneState[i_bone_idx_toe_IK].mWBone.m[3][2]+sz;
      SetTklHand(2+i,&g_PmdxWork,i_bone_idx_ankle, i, 0.7f,0.7f,0.7f, 0.0f,0.0f,sa*XM_PI/2.0f,
                 px,py,pz);
    }
  }
}

// ڐGFݒ
void SetupTouchArea(){
  int i_bone_ubody,i_bone_ubody2,iBone;
  int i_ankle,i_toe_IK,i_leg,i_knee;
  int id_foot,id_leg,id_calf;
  XMFLOAT3 leg_pos,knee_pos;
  float wx1,wy1,wz1,wx2,wy2,wz2;
  float rwy,rpx,rpy,rpz;
  float px,py,pz,sx,sy,sz,sx_leg,sy_leg,sz_leg,sx_calf,sy_calf,sz_calf;

  // 
  rwy=1.0f;
  rpy=g_aTklHand[0].mLocal.m[3][1];
  i_bone_ubody=search_bone_idx(&g_PmdxWork,"㔼g");
  if((i_bone_ubody>=0)&&(g_bone_idx_head>=0)){
    GetInitialBonePos(&wx1,&wy1,&wz1,&g_PmdxWork,g_bone_idx_head);
    GetInitialBonePos(&wx2,&wy2,&wz2,&g_PmdxWork,i_bone_ubody);
    rwy=fabs(wy1-wy2)/2.0f;
    rpy=(wy1+wy2)/2.0f;
  }
  i_bone_ubody2=search_bone_idx(&g_PmdxWork,"㔼g2");
  if(i_bone_ubody2>=0) iBone=i_bone_ubody2;
  else iBone=i_bone_ubody;
  rpx=g_aTklHand[0].mLocal.m[3][0];
  rpz=g_aTklHand[0].mLocal.m[3][2];
  SetTouchArea(g_aTouchArea,0, &g_PmdxWork,iBone, 0.5f,rwy,1.0f, 0.0f,0.0f,0.0f, rpx,rpy,rpz);
  rpx=g_aTklHand[1].mLocal.m[3][0];
  rpz=g_aTklHand[1].mLocal.m[3][2];
  SetTouchArea(g_aTouchArea,1 ,&g_PmdxWork,iBone, 0.5f,rwy,1.0f, 0.0f,0.0f,0.0f, rpx,rpy,rpz);

  // r
  for(int i=0;i<2;i++){
    if(i==0){ // 
      i_ankle=g_bone_idx_ankle_L;
      i_toe_IK=search_bone_idx(&g_PmdxWork,"ܐhj");
      i_leg=g_bone_idx_leg_L;
      i_knee=g_bone_idx_knee_L;
      leg_pos=g_leg_L_pos;
      knee_pos=g_knee_L_pos;
      id_foot=2;
      id_leg=4;
      id_calf=6;
    } else{ // E
      i_ankle=g_bone_idx_ankle_R;
      i_toe_IK=search_bone_idx(&g_PmdxWork,"Eܐhj");
      i_leg=g_bone_idx_leg_R;
      i_knee=g_bone_idx_knee_R;
      leg_pos=g_leg_R_pos;
      knee_pos=g_knee_R_pos;
      id_foot=3;
      id_leg=5;
      id_calf=7;
    }
    if((i_ankle>=0)&&(i_toe_IK)){
      // 
      px=g_PmdxWork.aBoneState[i_ankle].mWBone.m[3][0];
      sy=(g_PmdxWork.aBoneState[i_ankle].mWBone.m[3][1]-
          g_PmdxWork.aBoneState[i_toe_IK].mWBone.m[3][1]+0.3f)/2.0f;
      sx=min(fabs(px),
             g_PmdxWork.aBoneState[i_ankle].mWBone.m[3][1]-
             g_PmdxWork.aBoneState[i_toe_IK].mWBone.m[3][1]);
      sz=fabs(g_PmdxWork.aBoneState[i_ankle].mWBone.m[3][2]-
              g_PmdxWork.aBoneState[i_toe_IK].mWBone.m[3][2])*1.3/2.0f;
      py=g_PmdxWork.aBoneState[i_ankle].mWBone.m[3][1]-sy;
      pz=g_PmdxWork.aBoneState[i_toe_IK].mWBone.m[3][2]+sz;
      SetTouchArea(g_aTouchArea,id_foot, &g_PmdxWork, i_ankle,
                   sx,sy,sz, 0.0f,0.0f,0.0f, px,py,pz);
      if((i_leg>=0)&&(i_knee>=0)){
        // 
        sx_leg=fabs(leg_pos.x);
        sy_leg=(leg_pos.y-knee_pos.y)/2.0f;
        sz_leg=sx_leg;
        px=leg_pos.x;
        py=leg_pos.y-sy_leg;
        pz=leg_pos.z;
        SetTouchArea(g_aTouchArea,id_leg, &g_PmdxWork, i_leg,
                     sx_leg,sy_leg,sz_leg, 0.0f,0.0f,0.0f, px,py,pz);
        // ӂ͂
        sx_calf=sx*1.2f+fabs(knee_pos.x-g_PmdxWork.aBoneState[i_ankle].mWBone.m[3][0])/2.0f;;
        if(sx_calf>sx_leg) sx_calf=sx_leg;
        sy_calf=(knee_pos.y-g_PmdxWork.aBoneState[i_ankle].mWBone.m[3][1])/2.0f;
        sz_calf=sz*0.8+fabs(knee_pos.z-g_PmdxWork.aBoneState[i_ankle].mWBone.m[3][2])/2.0f;
        if(sz_calf>sz_leg) sz_calf=sz_leg;
        px=(knee_pos.x+g_PmdxWork.aBoneState[i_ankle].mWBone.m[3][0])/2.0f;
        if(fabs(px)<sx_calf){
          if(px>0.0f) px=sx_calf;
          else px=(-sx_calf);
        }
        py=knee_pos.y-sy_calf;
        pz=knee_pos.z+0.3f*sz_calf;
        SetTouchArea(g_aTouchArea,id_calf, &g_PmdxWork, i_knee,
                     sx_calf,sy_calf,sz_calf, 0.0f,0.0f,0.0f, px,py,pz);
      }
    }
  }
}

void delete_cube_for_hands(){
  if(g_pVertexBufferCube) g_pVertexBufferCube->Release();
  if(g_pIndexBufferCube) g_pIndexBufferCube->Release();
}

void ClearCross(){
  if( g_pVertexBufferCross ) g_pVertexBufferCross->Release();
  if( g_pIndexBufferCross ) g_pIndexBufferCross->Release();
}

void ClearPmdxWork(t_PmdxWork *pPmdxWork){
  if(pPmdxWork->pIndexBuffer) pPmdxWork->pIndexBuffer->Release();
  if(pPmdxWork->pVertexBuffer) pPmdxWork->pVertexBuffer->Release();
  delete [] pPmdxWork->aMorphRate;
  delete [] pPmdxWork->aBMorph;
  delete [] pPmdxWork->aBoneState;
  delete [] pPmdxWork->amRbBoneConv;
  delete [] pPmdxWork->aVertex;
  delete [] pPmdxWork->aMngTexture;
  delete [] pPmdxWork->aMngTexSph;
  delete [] pPmdxWork->aMngTexSpa;
  delete [] pPmdxWork->aiRbW;
  for(int iSimBodyNode=0;iSimBodyNode<pPmdxWork->nSimBodyNode;iSimBodyNode++){
    delete [] pPmdxWork->aSimBodyNode[iSimBodyNode].aiCnctSimBodyWire;
  }
  delete [] pPmdxWork->aSimBodyNode;
  delete [] pPmdxWork->aSimBodyWire;
  delete [] pPmdxWork->aSimBody2Bone;
  delete [] pPmdxWork->aiBoneExcludeGive;
  if(pPmdxWork->isPMX) destroy_pmx_data((t_pmx_data *)(pPmdxWork->pmdx_data));
  else destroy_pmd_data((t_pmd_data *)(pPmdxWork->pmdx_data));
}

void destroy_g_listMngTexture(){
  t_MngTexture *pMngTexture;

  while(g_listMngTexture){
    pMngTexture=g_listMngTexture->next;
    if(g_listMngTexture->pShaderResourceView)
      g_listMngTexture->pShaderResourceView->Release();
    delete g_listMngTexture;
    g_listMngTexture=pMngTexture;
  }
}

void destroy_g_listBoneBuf(){
  BoneBuf *pBoneBuf;

  while(g_listBoneBuf){
    pBoneBuf=g_listBoneBuf;
    g_listBoneBuf=g_listBoneBuf->next;
    pBoneBuf->pCBuffer->Release();
    delete pBoneBuf;
  }
}

void CleanupDX11Device(){
  if( g_pBlendState ) g_pBlendState->Release();
  if( g_pRasterizerStateSingleSide ) g_pRasterizerStateSingleSide->Release();
  if( g_pRasterizerStateDoubleSide ) g_pRasterizerStateDoubleSide->Release();
  if( g_pRasterizerStateWireframe ) g_pRasterizerStateWireframe->Release();
  if( g_pImmediateContext ) g_pImmediateContext->ClearState();
  if( g_pConstantBuffer ) g_pConstantBuffer->Release();
  if( g_pVertexLayout ) g_pVertexLayout->Release();
  if( g_pPMDXVertexLayout ) g_pPMDXVertexLayout->Release();
  if( g_pVertexShader ) g_pVertexShader->Release();
  if( g_pPMDXVertexShader ) g_pPMDXVertexShader->Release();
  if( g_pPixelShader ) g_pPixelShader->Release();
  if( g_pDepthStencil ) g_pDepthStencil->Release();
  if( g_pDepthStencilView ) g_pDepthStencilView->Release();
  if( g_pRenderTargetView ) g_pRenderTargetView->Release();
  if( g_pOVRDistortionTx ) g_pOVRDistortionTx->Release();
  if( g_pOVRRenderTargetView ) g_pOVRRenderTargetView->Release();
  if( g_pOVRShaderResourceView ) g_pOVRShaderResourceView->Release();
  if( g_pOVRVertexBufferL ) g_pOVRVertexBufferL->Release();
  if( g_pOVRVertexBufferR ) g_pOVRVertexBufferR->Release();
  if( g_pOVRVertexLayout ) g_pOVRVertexLayout->Release();
  if( g_pOVRIndexBuffer ) g_pOVRIndexBuffer->Release();
  if( g_pOVRConstantBuffer ) g_pOVRConstantBuffer->Release();
  if( g_pOVRVertexShader ) g_pOVRVertexShader->Release();
  if( g_pOVRPixelShader ) g_pOVRPixelShader->Release();
  if( g_pSwapChain ) g_pSwapChain->Release();
  if( g_pImmediateContext ) g_pImmediateContext->Release();
  if( g_pd3dDevice ) g_pd3dDevice->Release();
}

void CleanupOVRDevice(){
  if(g_pSFusion) delete g_pSFusion;
  g_pSensor.Clear();
  g_pHMD.Clear();
  g_pOVRManager.Clear();
  OVR::System::Destroy();
  OVR_DEBUG_STATEMENT(_CrtDumpMemoryLeaks());
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ){
  PAINTSTRUCT ps;
  HDC hdc;
  int xPos,yPos;

  switch( message ){
  case WM_PAINT:
    hdc = BeginPaint( hWnd, &ps );
    EndPaint( hWnd, &ps );
    break;

  case WM_DESTROY:
    PostQuitMessage( 0 );
    break;

  case WM_KEYDOWN:
    switch(wParam){
    case VK_ESCAPE:
      PostQuitMessage( 0 );
      break;
    case VK_SPACE:
      for(int i=0;i<NUM_OF_TKLHAND;i+=2){
        if(g_tkl_hand_active[i]==0){
          g_tkl_hand_active[i]=1;
          g_tkl_hand_active[i+1]=1;
          break;
        }
        else{
          g_tkl_hand_active[i]=0;
          g_tkl_hand_active[i+1]=0;
        }
      }
      break;
    case 'R':
      g_InitYaw=g_NowYaw;
      break;
    case 'P':
      g_EyePos= g_InitEyePos;
      break;
    case 'T':
      g_flgTouchVisible=1-g_flgTouchVisible;
      break;
    case 'L':
      g_flgFingerPosVisible=1-g_flgFingerPosVisible;
      break;
    case 'M':
      g_flgLMCMountedOnHMD=(!g_flgLMCMountedOnHMD);
      SetLMCPolicy(g_flgLMCMountedOnHMD);
      break;
    case 'A':
      g_EyeVelocity.x=(-g_EyeSpeed);
      break;
    case 'D':
      g_EyeVelocity.x=g_EyeSpeed;
      break;
    case 'S':
      g_EyeVelocity.z=(-g_EyeSpeed);
      break;
    case 'W':
      g_EyeVelocity.z=g_EyeSpeed;
      break;
    case 'Q':
      g_EyeBaseYawVelocity=(-g_EyeBaseYawSpeed);
      break;
    case 'E':
      g_EyeBaseYawVelocity=g_EyeBaseYawSpeed;
      break;
    case '5':
      g_EyeVelocity.y=(-g_EyeSpeed);
      break;
    case '6':
      g_EyeVelocity.y=g_EyeSpeed;
      break;
    case VK_RIGHT:
      g_leg_open_v_angle=g_leg_s_open_front;
      break;
    case VK_LEFT:
      g_leg_open_v_angle=(-g_leg_s_open_front); 
      break;
    case VK_UP:
      g_leg_front_v_angle=g_leg_s_open_front;
      break;
    case VK_DOWN:
      g_leg_front_v_angle=(-g_leg_s_open_front);
      break;
    }
    break;
  case WM_KEYUP:
    switch(wParam){
    case 'A':
    case 'D':
      g_EyeVelocity.x=0.0f;
      break;
    case 'S':
    case 'W':
      g_EyeVelocity.z=0.0f;
      break;
    case 'Q':
    case 'E':
      g_EyeBaseYawVelocity=0.0f;
      break;
    case '5':
    case '6':
      g_EyeVelocity.y=0.0f;
      break;
    case VK_RIGHT:
    case VK_LEFT:
      g_leg_open_v_angle=0.0f;
      break;
    case VK_UP:
    case VK_DOWN:
      g_leg_front_v_angle=0.0f;
      break;
    }
    break;
  case WM_LBUTTONDOWN:
    g_ui_mouse_down=1;
    g_VRMouseVisibleTime=3.0f;
    break;
  case WM_LBUTTONUP:
    g_ui_mouse_down=0;
    g_VRMouseVisibleTime=3.0f;
    break;
  case WM_RBUTTONDOWN:
    if(g_aUIPanels[0].state!=3){
      g_aUIPanels[0].state=3;
      LayoutUIPanels();
    }
    g_VRMousePos_x=0.0f;
    g_VRMousePos_y=0.0f;
    g_VRMouseVisibleTime=3.0f;
    break;
  case WM_MOUSEMOVE:
    xPos = GET_X_LPARAM(lParam); 
    yPos = GET_Y_LPARAM(lParam);
    g_VRMousePos_x+=((float)(xPos-g_MousePos_x))*UI_PANEL_SCALE;
    g_VRMousePos_y-=((float)(yPos-g_MousePos_y))*UI_PANEL_SCALE;
    if((g_MousePos_x<10)||(g_MousePos_x>g_width-10)||
       (g_MousePos_y<10)||(g_MousePos_y>g_height-10)){
      g_MousePos_x=g_width/2;
      g_MousePos_y=g_height/2;
      SetCursorPos(g_MousePos_x,g_MousePos_y);
    } else{
      g_MousePos_x=xPos;
      g_MousePos_y=yPos;
    }
    g_VRMouseVisibleTime=3.0f;
    break;
  default:
    return DefWindowProc( hWnd, message, wParam, lParam );
  }
  return 0;
}

// PMD/PMX`
void render_pmdx(t_PmdxWork *pPmdxWork,ConstantBuffer &cb1){
  int nMaterial,do_flg;

  // Set vertex buffer
  UINT stride = sizeof( PMDXVertex );
  UINT offset = 0;
  g_pImmediateContext->IASetVertexBuffers( 0, 1, &(pPmdxWork->pVertexBuffer), &stride, &offset );
  // Set index buffer
  if(pPmdxWork->isPMX)
    g_pImmediateContext->IASetIndexBuffer( pPmdxWork->pIndexBuffer, DXGI_FORMAT_R32_UINT, 0 );
  else
    g_pImmediateContext->IASetIndexBuffer( pPmdxWork->pIndexBuffer, DXGI_FORMAT_R16_UINT, 0 );
  // {[萔obt@
  g_pImmediateContext->VSSetConstantBuffers( 1, 1, &(pPmdxWork->pBoneBuf->pCBuffer) );
  // Set the world matrix
  cb1.mWorld=XMMatrixTranspose(g_World);

  int m,fvc;
  int drawed_fvc=0;
  cb1.ZOffset=0.0f;
  if(pPmdxWork->isPMX) nMaterial=((t_pmx_data *)(pPmdxWork->pmdx_data))->material_count;
  else nMaterial=((t_pmd_data *)(pPmdxWork->pmdx_data))->material_count;
  for(m=0;m<nMaterial;m++){
    do_flg=1;
    if(pPmdxWork->aMngTexture[m]==nullptr){
      cb1.TexStrength=0.0f;
    }
    else{
      g_pImmediateContext->
        PSSetShaderResources(0, 1, &(pPmdxWork->aMngTexture[m]->pShaderResourceView));
      cb1.TexStrength=1.0f;
    }
    if(pPmdxWork->aMngTexSph[m]==nullptr){
      cb1.SphStrength=0.0f;
    }
    else{
      g_pImmediateContext->
        PSSetShaderResources(1, 1, &(pPmdxWork->aMngTexSph[m]->pShaderResourceView));
      cb1.SphStrength=1.0f;
    }
    if(pPmdxWork->aMngTexSpa[m]==nullptr){
      cb1.SpaStrength=0.0f;
    }
    else{
      g_pImmediateContext->
        PSSetShaderResources(2, 1, &(pPmdxWork->aMngTexSpa[m]->pShaderResourceView));
      cb1.SpaStrength=1.0f;
    }
    if(pPmdxWork->isPMX){
      cb1.DCol.x=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color.x;
      cb1.DCol.y=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color.y;
      cb1.DCol.z=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color.z;
      cb1.DCol.w=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color.w;
      if(cb1.DCol.w<=0.0f) do_flg=0;
      else{
        cb1.ACol.x=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].ambient_color.x;
        cb1.ACol.y=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].ambient_color.y;
        cb1.ACol.z=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].ambient_color.z;
        cb1.SCol.x=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].specular_color.x;
        cb1.SCol.y=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].specular_color.y;
        cb1.SCol.z=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].specular_color.z;
        cb1.SPower=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].specularity;
        if(((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].draw_flags & 0x01){ // ʕ`
          g_pImmediateContext->RSSetState(g_pRasterizerStateDoubleSide);
        } else{ // Жʕ`
          g_pImmediateContext->RSSetState(g_pRasterizerStateSingleSide);
        }
      }
      fvc=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].face_vert_count;
    } else{
      cb1.DCol.x=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color[0];
      cb1.DCol.y=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color[1];
      cb1.DCol.z=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color[2];
      cb1.DCol.w=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].alpha;
      cb1.ACol.x=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].mirror_color[0];
      cb1.ACol.y=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].mirror_color[1];
      cb1.ACol.z=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].mirror_color[2];
      cb1.SCol.x=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].specular_color[0];
      cb1.SCol.y=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].specular_color[1];
      cb1.SCol.z=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].specular_color[2];
      cb1.SPower=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].specularity;
      fvc=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].face_vert_count;
      if(cb1.DCol.w>=1.0f){ // sȂЖʕ`
        g_pImmediateContext->RSSetState(g_pRasterizerStateSingleSide);
      } else{ // Ȃ痼ʕ`
        g_pImmediateContext->RSSetState(g_pRasterizerStateDoubleSide);
      }
    }
    if(do_flg){
      g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
      g_pImmediateContext->DrawIndexed(fvc,drawed_fvc,0);
    }
    drawed_fvc+=fvc;
    cb1.ZOffset+=0.000001f; // ̍ގ͑O̍ގ኱Oɕ`悷
  }
  cb1.ZOffset=0.0f;
}

int chk_tkl_hand_active(){
  int iRes=0;
  for(int i=0;i<NUM_OF_TKLHAND;i+=2){
    if(g_tkl_hand_active[i]){
      iRes=1;
      break;
    }
  }
  return iRes;
}

// ȈՃnh𓮂
void MoveTklHand(float dt){ // -> ֐AѕύX
  g_FingerRefAngleNow+=dt*360.0f*XM_PI/180.0f;
  if(g_FingerRefAngleNow>2.0f*XM_PI) g_FingerRefAngleNow-=2.0f*XM_PI;
  // {[Ǐ]
  for(int iTklHand=0;iTklHand<NUM_OF_TKLHAND;iTklHand++){
    if(g_tkl_hand_active[iTklHand]){
      int iBone=g_aTklHand[iTklHand].iBone;
      t_PmdxWork *wkPmdxWork=g_aTklHand[iTklHand].pPmdxWork;
      if(wkPmdxWork && (iBone>=0)){
        XMMATRIX mLocal=XMLoadFloat4x4(&(g_aTklHand[iTklHand].mLocal));
        XMMATRIX mWBone=XMLoadFloat4x4(&(wkPmdxWork->aBoneState[iBone].mWBone));
        XMMATRIX mWorld=mLocal*mWBone;
        XMStoreFloat4x4(&(g_aTklHand[iTklHand].mWorld),mWorld);
      }
    }
  }
}

// ȈՃnh`
void RenderTklHand(ConstantBuffer &cb1){ // ->ѕύX
  XMFLOAT3 HandPos;
  XMMATRIX WorldCenter;
  XMMATRIX WorldFinger,WorldJoint;
  float g_FingerAngle1Max=30; //1֐ߍőpx
  float g_FingerAngle2Max=120; //2֐ߍőpx
  const int NumOfFinger=8; // w̖{
  float sa;
  float FingerAngle1Now[NumOfFinger];
  float FingerAngle2Now[NumOfFinger];
  int i,j,k;

  // ẘpx̐ݒ
  int cnv[]={0,2,4,6,1,3,5,7};
  for(i=0;i<NumOfFinger;i++){
    FingerAngle1Now[cnv[i]]= -g_FingerAngle1Max*0.5f*
		                     (1.0f+sin(g_FingerRefAngleNow+i*2.0f*XM_PI/NumOfFinger));
    FingerAngle2Now[cnv[i]]= g_FingerAngle2Max*0.5f*
      (1.0f+sin(g_FingerRefAngleNow+i*2.0f*XM_PI/NumOfFinger+XM_PI/2.0f));
  }
  // Set vertex buffer
  UINT stride = sizeof( SimpleVertex );
  UINT offset = 0;
  g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pVertexBufferCube, &stride, &offset );
  // Set index buffer
  g_pImmediateContext->IASetIndexBuffer( g_pIndexBufferCube, DXGI_FORMAT_R16_UINT, 0 );
  // Жʕ`
  g_pImmediateContext->RSSetState(g_pRasterizerStateSingleSide);
  // ގ̐ݒ
  cb1.TexStrength=0.0f;
  cb1.SphStrength=0.0f;
  cb1.SpaStrength=0.0f;
  cb1.DCol=XMFLOAT4(0.8f, 0.5f, 0.8f, 1.0f);
  cb1.ACol=XMFLOAT3(0.75f, 0.25f, 0.75f);
  cb1.SCol=XMFLOAT3(0.2f, 0.05f, 0.2f);
  cb1.SPower=5.0;
  // ê̎pvZƕ`
  XMMATRIX rotX90=XMMatrixRotationX(XM_PI/2.0f);
  XMMATRIX scaleY2=XMMatrixScaling(1.0f,2.0f,1.0f);
  XMMATRIX transY1=XMMatrixTranslation(0.0f,1.0f,0.0f);
  XMMATRIX transY4=XMMatrixTranslation(0.0f,4.0f,0.0f);
  for(i=0;i<NUM_OF_TKLHAND;i++){
    if(g_tkl_hand_active[i]){
      if(g_aTklHand[i].isRight==0) sa=(-1.0); // 
      else sa=(1.0); // E
      // 
      WorldCenter=XMMatrixScaling(0.1f,0.1f,0.1f)*XMLoadFloat4x4(&(g_aTklHand[i].mWorld));
      cb1.mWorld=XMMatrixTranspose(WorldCenter);
      g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
      g_pImmediateContext->DrawIndexed(36,0,0);
      // w
      for(j=0;j<NumOfFinger;j++){
        for(k=0;k<2;k++){
          if(k==0)
            WorldJoint=XMMatrixRotationZ(sa*FingerAngle1Now[j]*XM_PI/180.0f)*transY1;
          else
            WorldJoint=XMMatrixRotationZ(sa*FingerAngle2Now[j]*XM_PI/180.0f)*transY4*WorldJoint;
          WorldFinger=transY1*scaleY2*WorldJoint;
          WorldFinger=WorldFinger*XMMatrixRotationX(j*2.0f*XM_PI/NumOfFinger);
          cb1.mWorld=XMMatrixTranspose(WorldFinger*WorldCenter);
          g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
          g_pImmediateContext->DrawIndexed(36,0,0);
        }
      }
    }
  }
}

// ̔F
void RecognizeTickle(float dt){
  LMCHand *wkLMCHand;
  TouchArea *wkTouchArea;
  XMMATRIX mFinger,mWork1;
  XMVECTOR vWk1;
  int i;

  MoveTouchArea(g_aTouchArea,NUM_OF_TOUCHAREA);
  wkLMCHand=g_listLMCHand;
  while(wkLMCHand){
    if(wkLMCHand->validLeftRight){
      for(i=0;i<5;i++){
        vWk1=GetLMCFingerPos(wkLMCHand,&g_mWorldLMC,i);
        RecognizeTouch(g_aTouchArea,NUM_OF_TOUCHAREA,
                       XMVectorGetX(vWk1),XMVectorGetY(vWk1),XMVectorGetZ(vWk1));
      }
    }
    wkLMCHand=wkLMCHand->next;
  }
  g_fTouchValTotal=0.0f;
  for(int idx=0;idx<NUM_OF_TOUCHAREA;idx++){
    g_afTouchValArea[idx]=0.0f;
    g_avTouchCenter[idx]=XMFLOAT3(0.0f, 0.0f, 0.0f);
    wkTouchArea=&(g_aTouchArea[idx]);
    for(int iz=0;iz<wkTouchArea->ncz;iz++){
      float cz=(-1.0f)+(wkTouchArea->scz)*(((float)iz)+0.5f);
      for(int iy=0;iy<wkTouchArea->ncy;iy++){
        float cy=(-1.0f)+(wkTouchArea->scy)*(((float)iy)+0.5f);
        for(int ix=0;ix<wkTouchArea->ncx;ix++){
          float cx=(-1.0f)+(wkTouchArea->scx)*(((float)ix)+0.5f);
          int iCol=iz*(wkTouchArea->ncx)*(wkTouchArea->ncy)+iy*(wkTouchArea->ncx)+ix;
          float fVal=wkTouchArea->aColumn[iCol].fVal-wkTouchArea->aColumn[iCol].fRegist;
          if(fVal<0.0f) fVal=0.0f;
          g_fTouchValTotal+=fVal;
          g_afTouchValArea[idx]+=fVal;
          g_avTouchCenter[idx].x+=cx*fVal;
          g_avTouchCenter[idx].y+=cy*fVal;
          g_avTouchCenter[idx].z+=cz*fVal;
        }
      }
    }
    if(g_afTouchValArea[idx]>0.0f){
      g_avTouchCenter[idx].x/=g_afTouchValArea[idx];
      g_avTouchCenter[idx].y/=g_afTouchValArea[idx];
      g_avTouchCenter[idx].z/=g_afTouchValArea[idx];
    }
  }
  DecTouchColumnVal(g_aTouchArea,NUM_OF_TOUCHAREA,dt);
}

// ڐGF󋵕\
void RenderTouchRecog(ConstantBuffer &cb1){
  TouchArea *wkTouchArea;
  XMMATRIX mWork1,mWorld;

  cb1.TexStrength=0.0f;
  cb1.SphStrength=0.0f;
  cb1.SpaStrength=0.0f;
  cb1.SPower=1.0f;
  cb1.SCol=XMFLOAT3(0.0f, 0.0f, 0.0f);
  // Set vertex buffer
  UINT stride = sizeof( SimpleVertex );
  UINT offset = 0;
  g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pVertexBufferCube, &stride, &offset );
  // Set index buffer
  g_pImmediateContext->IASetIndexBuffer( g_pIndexBufferCube, DXGI_FORMAT_R16_UINT, 0 );
  // C[t[\ɂ
  g_pImmediateContext->RSSetState(g_pRasterizerStateWireframe);
  for(int iTouchArea=0;iTouchArea<NUM_OF_TOUCHAREA;iTouchArea++){
    wkTouchArea=&(g_aTouchArea[iTouchArea]);
    cb1.DCol=XMFLOAT4(0.0f, 1.0f, 1.0f, 1.0f);
    cb1.ACol=XMFLOAT3(0.0f, 1.0f, 1.0f);
    mWorld=XMLoadFloat4x4(&(wkTouchArea->mWorld));
    cb1.mWorld = XMMatrixTranspose(mWorld);
    g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
    g_pImmediateContext->DrawIndexed( 36, 0, 0 );
    for(int iz=0;iz<wkTouchArea->ncz;iz++){
      for(int iy=0;iy<wkTouchArea->ncy;iy++){
        for(int ix=0;ix<wkTouchArea->ncx;ix++){
          int iCol=iz*(wkTouchArea->ncx)*(wkTouchArea->ncy)+iy*(wkTouchArea->ncx)+ix;
          if(wkTouchArea->aColumn[iCol].isTouchedPrev){
            cb1.DCol=XMFLOAT4(0.0f, 1.0f, 0.0f, 1.0f);
            cb1.ACol.x=cb1.DCol.x;
            cb1.ACol.y=cb1.DCol.y;
            cb1.ACol.z=cb1.DCol.z;
            mWork1=XMMatrixScaling(wkTouchArea->scx*0.5f/2.0f,
                                   wkTouchArea->scy*0.5f/2.0f,
                                   wkTouchArea->scz*0.5f/2.0f)*
              XMMatrixTranslation((ix+0.5f)*(wkTouchArea->scx)-1.0f,
                                  (iy+0.5f)*(wkTouchArea->scy)-1.0f,
                                  (iz+0.5f)*(wkTouchArea->scz)-1.0f);
            mWork1=mWork1*mWorld;
            cb1.mWorld = XMMatrixTranspose(mWork1);
            g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
            g_pImmediateContext->DrawIndexed( 36, 0, 0 );
          }
          float fwk1=wkTouchArea->aColumn[iCol].fVal;
          float fwk2=wkTouchArea->aColumn[iCol].fRegist/1.0f;
          cb1.DCol=XMFLOAT4(fwk1, fwk2, 1.0f, 1.0f);
          cb1.ACol.x=cb1.DCol.x;
          cb1.ACol.y=cb1.DCol.y;
          cb1.ACol.z=cb1.DCol.z;
          mWork1=XMMatrixScaling(wkTouchArea->scx*0.8f/2.0f,
                                 wkTouchArea->scy*0.8f/2.0f,
                                 wkTouchArea->scz*0.8f/2.0f)*
            XMMatrixTranslation((ix+0.5f)*(wkTouchArea->scx)-1.0f,
                                (iy+0.5f)*(wkTouchArea->scy)-1.0f,
                                (iz+0.5f)*(wkTouchArea->scz)-1.0f);
          mWork1=mWork1*mWorld;
          cb1.mWorld = XMMatrixTranspose(mWork1);
          g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
          g_pImmediateContext->DrawIndexed( 36, 0, 0 );
        }
      }
    }
  }
}

int IsTickled(int idArea){ // -1:S
  int iRtn;
  if(idArea==(-1)) iRtn=(chk_tkl_hand_active() || (g_fTouchValTotal>0.8f));
  else iRtn=(g_tkl_hand_active[idArea])||
    ((g_fTouchValTotal>0.8f)&&(g_afTouchValArea[idArea]>0.4f));
  return iRtn;
}

// f̕\ς
void move_face(float dt){
  float mspeed= 5.0f;
  float morph_rate,bkval;

  int is_tickled=IsTickled(-1);
  // Ԃ̍XV
  g_reaction_blink_interval+=dt;
  if(g_reaction_blink_interval>10.0f){
    g_reaction_blink_time+=dt;
    if(g_reaction_blink_time>=1.0f){
      g_reaction_blink_time=0.0f;
      g_reaction_blink_interval=0.0f;
    }
  }
  if(is_tickled){
    g_reaction_tkl_time+=dt;
    if(g_reaction_tkl_time>60.0f) g_reaction_tkl_time-=1.0f;
  }
  else{
    if(g_reaction_tkl_time>0.0){
      g_reaction_tkl_time=max(g_reaction_tkl_time-dt,1.0f);
      if(g_reaction_tkl_time<=10.0f){
        g_reaction_anger_time+=dt;
        if(g_reaction_anger_time>=1.0f) g_reaction_anger_time-=1.0f;
      }
      else{
        g_reaction_breath_time+=dt;
        if(g_reaction_breath_time>=1.0f) g_reaction_breath_time-=1.0f;
      }
    }
  }
  // ܂΂
  morph_rate=0.0f;
  if(!is_tickled){
    if((g_reaction_blink_interval>10.0f)&&(g_reaction_tkl_time<=10.0f))
      morph_rate=0.5f*(1.0f-cos(g_reaction_blink_time*2.0f*XM_PI));
    else if(g_reaction_tkl_time>10.0f) morph_rate=1.0f;
  }
  set_morph_rate(&g_PmdxWork,g_morph_idx_blink,morph_rate,mspeed,dt);
  // ͂
  if(is_tickled&&(g_reaction_tkl_time>30.0f)) morph_rate=1.0f;
  else morph_rate=0.0f;
  set_morph_rate(&g_PmdxWork,g_morph_idx_hau,morph_rate,mspeed,dt);
  // ΂
  morph_rate=0.0f;
  if(is_tickled){
    if(g_reaction_tkl_time<=30.0f){
      if(g_reaction_blink_interval>10.0f)
        morph_rate=1.0f-0.5*(1.0f-cos(g_reaction_blink_time*2.0f*XM_PI));
      else morph_rate=1.0f;
    }
  }
  set_morph_rate(&g_PmdxWork,g_morph_idx_laugh,morph_rate,mspeed,dt);
  // EBN
  bkval=morph_rate;
  morph_rate=0.0f;
  if(is_tickled){
    if(g_reaction_tkl_time<=30.0f){
      if(g_reaction_blink_interval>10.0f)
        morph_rate=1.0f-bkval;
    }
  }
  set_morph_rate(&g_PmdxWork,g_morph_idx_wink,morph_rate,mspeed,dt);
  // 
  morph_rate=0.0f;
  if(is_tickled) morph_rate=0.9+0.05*(1.0f-cos(g_reaction_tkl_time*4.0f*XM_PI));
  else if(g_reaction_tkl_time>10.0f) morph_rate=0.25*(1.0f-cos(g_reaction_breath_time*2.0f*XM_PI));
  set_morph_rate(&g_PmdxWork,g_morph_idx_a,morph_rate,mspeed,dt);
  // 
  morph_rate=0.0f;
  if(is_tickled) morph_rate=0.25*(1.0f-cos(g_reaction_tkl_time*4.0f*XM_PI));
  else if((g_reaction_tkl_time>0.0f)&&(g_reaction_tkl_time<=10.0f)) morph_rate=0.5;
  set_morph_rate(&g_PmdxWork,g_morph_idx_i,morph_rate,mspeed,dt);
  // 
  morph_rate=0.0f;
  if(!is_tickled){
    if(g_reaction_tkl_time>10.0f) morph_rate=1.0f;
    else if(g_reaction_tkl_time>0.0f)
      morph_rate=0.5f*(1.0f-cos(g_reaction_anger_time*2.0f*XM_PI));
  }
  set_morph_rate(&g_PmdxWork,g_morph_idx_o,morph_rate,mspeed,dt);
  // 
  if(is_tickled&&(g_reaction_tkl_time>15.0f)) morph_rate=1.0f;
  else if((!is_tickled)&&(g_reaction_tkl_time>10.0f)) morph_rate=1.0f;
  else morph_rate=0.0f;
  set_morph_rate(&g_PmdxWork,g_morph_idx_trbl,morph_rate,mspeed,dt);
  // {
  morph_rate=0.0f;
  if(!is_tickled){
    if((g_reaction_tkl_time>0.0f)&&(g_reaction_tkl_time<=10.0f)) morph_rate=1.0f;
  }
  set_morph_rate(&g_PmdxWork,g_morph_idx_anger,morph_rate,mspeed,dt);
}

// f̓𓮂
void move_head(float dt,XMMATRIX &nowRollPitchYawPos){
  float fNHAngleX,fNHAngleY,fDist,fDiff;
  float fdx,fdy,fdz,fh,fwx,fwy,fwz;
  XMVECTOR vEyeCenter,vEyePos;
  XMMATRIX mNeck,mNeckInv,mBone;
  float max_adiff;
  int iParent;
  XMVECTOR vDet;

  float maxasp_nml=XM_PI/4.0f;
  float maxasp_tk=XM_PI;
  max_adiff=dt*maxasp_nml;
  fNHAngleX=g_fNHAngleX;
  fNHAngleY=g_fNHAngleY;
  int is_tickled=IsTickled(-1);
  if((g_bone_idx_neck>=0)&&(g_bone_idx_head>=0)){
    if(is_tickled){
      float fNeckAngleMax=15.0f*XM_PI/180.0f;
      float fTklTimeNormalized=g_reaction_tkl_time/(1.0f+g_reaction_tkl_time);
      float fNeckAngleMin=(-15.0f)*fTklTimeNormalized*XM_PI/180.0f;
      float fTklValTotal=g_fTouchValTotal;
      for(int i=0;i<NUM_OF_TKLHAND;i++) fTklValTotal+=2.0f*g_tkl_hand_active[i];
      const float fTklValMax=3.0;
      float fTklValNormalized=fTklValTotal/fTklValMax;
      fNHAngleX=fNeckAngleMax*fTklValNormalized+fNeckAngleMin;
      if(fNHAngleX>fNeckAngleMax) fNHAngleX=fNeckAngleMax;
      if(fNHAngleX>g_fNHAngleX)
        fNHAngleX=g_fNHAngleX+dt*12.0f*(fNHAngleX-g_fNHAngleX);
      else fNHAngleX=g_fNHAngleX+dt*(fNHAngleX-g_fNHAngleX);
      fNHAngleY=0.0f;
      max_adiff=dt*maxasp_tk;
    } else if(g_reaction_tkl_time>10.0f){
      fNHAngleX=(-15.0f*XM_PI/180.0f);
      fNHAngleY=0.0f;
    } else if(g_bone_idx_r_eye>=0){
      // 񂩂ڂ܂ł̍߂
      GetInitialBonePos(&fwx,&fh,&fwz,&g_PmdxWork,g_bone_idx_r_eye);
      GetInitialBonePos(&fwx,&fwy,&fwz,&g_PmdxWork,g_bone_idx_neck);
      fh-=fwy;
      // Ƃ̑Έʒu߂
      vEyeCenter = XMVector3Transform(
        XMVectorSet(0.0f, g_eyeheight, g_eyeforward,0.0f),nowRollPitchYawPos);
      mNeck=XMMatrixIdentity();
      mNeck.r[3]=XMVectorSet(g_PmdxWork.aBoneState[g_bone_idx_neck].mLBone.m[3][0],
                             g_PmdxWork.aBoneState[g_bone_idx_neck].mLBone.m[3][1],
                             g_PmdxWork.aBoneState[g_bone_idx_neck].mLBone.m[3][2],1.0f);
      iParent=g_PmdxWork.aBoneState[g_bone_idx_neck].iParent;
      if(iParent>=0) mNeck=mNeck*XMLoadFloat4x4(&(g_PmdxWork.aBoneState[iParent].mWBone));
      mNeckInv=XMMatrixInverse(&vDet,mNeck);
      vEyePos=XMVector3Transform(vEyeCenter,mNeckInv);
      fdx=XMVectorGetX(vEyePos);
      fdy=XMVectorGetY(vEyePos);
      fdz=XMVectorGetZ(vEyePos);
      // Xɑ΂]߂
      fDist=sqrt(fdx*fdx+fdy*fdy+fdz*fdz);
      if(fabs(fh)<=fabs(fDist)) fNHAngleX=(atan2(fdy,fDist)-asin(fh/fDist))/2.0f;
      if(fNHAngleX>15.0f*XM_PI/180.0f) fNHAngleX=15.0f*XM_PI/180.0f;
      else if(fNHAngleX<(-15.0f*XM_PI/180.0f)) fNHAngleX=(-15.0f*XM_PI/180.0f);
      // Yɑ΂]߂
      fNHAngleY= -atan2(fdx,-fdz)/2.0f;
      if(fNHAngleY>(30.0f*XM_PI/180.0f)) fNHAngleY=30.0f*XM_PI/180.0f;
      else if(fNHAngleY<(-30.0f*XM_PI/180.0f)) fNHAngleY=(-30.0f*XM_PI/180.0f);
    }
    // xlČ݂̊pxXV
    fDiff=fNHAngleX-g_fNHAngleX;
    if(fDiff>max_adiff) fDiff=max_adiff;
    else if(fDiff<(-max_adiff)) fDiff=(-max_adiff);
    g_fNHAngleX+=fDiff;
    fDiff=fNHAngleY-g_fNHAngleY;
    if(fDiff>max_adiff) fDiff=max_adiff;
    else if(fDiff<(-max_adiff)) fDiff=(-max_adiff);
    g_fNHAngleY+=fDiff;
    // {[ɔf
    mBone=XMMatrixRotationX(g_fNHAngleX)*XMMatrixRotationY(g_fNHAngleY);
    mBone.r[3]=XMVectorSet(g_PmdxWork.aBoneState[g_bone_idx_neck].mLBone.m[3][0],
                           g_PmdxWork.aBoneState[g_bone_idx_neck].mLBone.m[3][1],
                           g_PmdxWork.aBoneState[g_bone_idx_neck].mLBone.m[3][2],
                           g_PmdxWork.aBoneState[g_bone_idx_neck].mLBone.m[3][3]);
    UpdateLBone(&g_PmdxWork,g_bone_idx_neck,&mBone);
    mBone.r[3]=XMVectorSet(g_PmdxWork.aBoneState[g_bone_idx_head].mLBone.m[3][0],
                           g_PmdxWork.aBoneState[g_bone_idx_head].mLBone.m[3][1],
                           g_PmdxWork.aBoneState[g_bone_idx_head].mLBone.m[3][2],
                           g_PmdxWork.aBoneState[g_bone_idx_head].mLBone.m[3][3]);
    UpdateLBone(&g_PmdxWork,g_bone_idx_head,&mBone);
  }
}

// f̑𓮂
void move_ankles(float dt){
  const float ankles_shake_wx=10.0f*XM_PI/180.0f;
  const float ankles_shake_wy=15.0f*XM_PI/180.0f;
  float fDiff;
  float tg_rx,tg_ry;
  float max_asp,max_adiff;
  int iLR;
  XMMATRIX mBone;

  g_ankles_shake_ref_ange+=2.0f*XM_PI*dt;
  if(g_ankles_shake_ref_ange>=(2.0f*XM_PI)) g_ankles_shake_ref_ange-=2.0f*XM_PI;
  for(iLR=0;iLR<2;iLR++){
    tg_rx=0.0f;
    tg_ry=0.0f;
    max_asp=0.5f;
    if(iLR==0){ // 
      if(IsTickled(2)){
        tg_rx=sin(g_ankles_shake_ref_ange)*ankles_shake_wx;
        tg_ry=cos(g_ankles_shake_ref_ange)*ankles_shake_wy;
        max_asp=1.0f;
      }
    } else{ // E
      if(IsTickled(3)){
        tg_rx=sin(g_ankles_shake_ref_ange)*ankles_shake_wx;
        tg_ry=(-cos(g_ankles_shake_ref_ange)*ankles_shake_wy);
        max_asp=1.0f;
      }
    }
    max_adiff=dt*max_asp;
    fDiff=tg_rx-g_AnkleLAngleX[iLR];
    if(fDiff>max_adiff) fDiff=max_adiff;
    else if(fDiff<(-max_adiff)) fDiff=(-max_adiff);
    g_AnkleLAngleX[iLR]+=fDiff;
    fDiff=tg_ry-g_AnkleLAngleY[iLR];
    if(fDiff>max_adiff) fDiff=max_adiff;
    else if(fDiff<(-max_adiff)) fDiff=(-max_adiff);
    g_AnkleLAngleY[iLR]+=fDiff;
    if(iLR==0){ // 
      if(g_bone_idx_ankle_L>=0){
        mBone=XMMatrixRotationX(g_AnkleLAngleX[iLR])*XMMatrixRotationY(g_AnkleLAngleY[iLR]);
        mBone.r[3]=XMVectorSet(g_PmdxWork.aBoneState[g_bone_idx_ankle_L].mLBone.m[3][0],
                               g_PmdxWork.aBoneState[g_bone_idx_ankle_L].mLBone.m[3][1],
                               g_PmdxWork.aBoneState[g_bone_idx_ankle_L].mLBone.m[3][2],
                               g_PmdxWork.aBoneState[g_bone_idx_ankle_L].mLBone.m[3][3]);
        UpdateLBone(&g_PmdxWork,g_bone_idx_ankle_L,&mBone);
      }
    } else{ // E
      if(g_bone_idx_ankle_R>=0){
        mBone=XMMatrixRotationX(g_AnkleLAngleX[iLR])*XMMatrixRotationY(g_AnkleLAngleY[iLR]);
        mBone.r[3]=XMVectorSet(g_PmdxWork.aBoneState[g_bone_idx_ankle_R].mLBone.m[3][0],
                               g_PmdxWork.aBoneState[g_bone_idx_ankle_R].mLBone.m[3][1],
                               g_PmdxWork.aBoneState[g_bone_idx_ankle_R].mLBone.m[3][2],
                               g_PmdxWork.aBoneState[g_bone_idx_ankle_R].mLBone.m[3][3]);
        UpdateLBone(&g_PmdxWork,g_bone_idx_ankle_R,&mBone);
      }
    }
  }
}

// f̍Spς
void change_restriction_pose(float dt){
  XMMATRIX mBone,mRotX;
  XMVECTOR vLegPos,vKneePos,vAnklePos;

  g_leg_open_angle+=dt*g_leg_open_v_angle;
  if(g_leg_open_angle>(45.0f*XM_PI/180.0f)) g_leg_open_angle=45.0f*XM_PI/180.0f;
  else if(g_leg_open_angle<0.0f) g_leg_open_angle=0.0f;
  g_leg_front_angle+=dt*g_leg_front_v_angle;
  if(g_leg_front_angle>(90.0f*XM_PI/180.0f)) g_leg_front_angle=90.0f*XM_PI/180.0f;
  else if(g_leg_front_angle<0.0f) g_leg_front_angle=0.0f;
  mRotX=XMMatrixRotationX(g_leg_front_angle);
  mBone=XMMatrixRotationZ(g_leg_open_angle)*mRotX;
  vLegPos=XMLoadFloat3(&g_leg_L_pos);
  vAnklePos=XMVector3Transform(XMLoadFloat3(&g_ankle_L_pos)-vLegPos,mBone)+vLegPos;
  UpdateSimBodyNodePos(&g_PmdxWork,7,vAnklePos);
  vKneePos=XMVector3Transform(XMLoadFloat3(&g_knee_L_pos)-vLegPos,mBone)+vLegPos;
  XMStoreFloat3(&g_knee_L_pos_now,vKneePos);
  mBone=XMMatrixRotationZ(-g_leg_open_angle)*mRotX;
  vLegPos=XMLoadFloat3(&g_leg_R_pos);
  vAnklePos=XMVector3Transform(XMLoadFloat3(&g_ankle_R_pos)-vLegPos,mBone)+vLegPos;
  UpdateSimBodyNodePos(&g_PmdxWork,13,vAnklePos);
  vKneePos=XMVector3Transform(XMLoadFloat3(&g_knee_R_pos)-vLegPos,mBone)+vLegPos;
  XMStoreFloat3(&g_knee_R_pos_now,vKneePos);
  if(!g_flg_SimBodyEnable){
    if((g_bone_idx_leg_L>=0)&&(g_bone_idx_leg_R>=0)){
      mRotX=XMMatrixRotationX(g_leg_front_angle);
      mBone=XMMatrixRotationZ(g_leg_open_angle)*mRotX;
      mBone.r[3]=XMVectorSet(g_PmdxWork.aBoneState[g_bone_idx_leg_L].mLBone.m[3][0],
                             g_PmdxWork.aBoneState[g_bone_idx_leg_L].mLBone.m[3][1],
                             g_PmdxWork.aBoneState[g_bone_idx_leg_L].mLBone.m[3][2],
                             g_PmdxWork.aBoneState[g_bone_idx_leg_L].mLBone.m[3][3]);
      UpdateLBone(&g_PmdxWork,g_bone_idx_leg_L,&mBone);
      mBone=XMMatrixRotationZ(-g_leg_open_angle)*mRotX;
      mBone.r[3]=XMVectorSet(g_PmdxWork.aBoneState[g_bone_idx_leg_R].mLBone.m[3][0],
                             g_PmdxWork.aBoneState[g_bone_idx_leg_R].mLBone.m[3][1],
                             g_PmdxWork.aBoneState[g_bone_idx_leg_R].mLBone.m[3][2],
                             g_PmdxWork.aBoneState[g_bone_idx_leg_R].mLBone.m[3][3]);
      UpdateLBone(&g_PmdxWork,g_bone_idx_leg_R,&mBone);
    }
  }
}

void AddForceTickle(int iTouchArea,int iSimBodyNode0, int iSimBodyNode1,
                      XMVECTOR *vForce0,XMVECTOR *vForce1){
  if(IsTickled(iTouchArea)){
    XMVECTOR vCenter=XMVector3Transform(XMLoadFloat3(&(g_avTouchCenter[iTouchArea])),
                                        XMLoadFloat4x4(&(g_aTouchArea[iTouchArea].mWorld)));
    float fTouchVal=g_afTouchValArea[iTouchArea];
    if(iTouchArea<2){ // ̊ȈՃnhl
      if(g_tkl_hand_active[iTouchArea]){
        XMVECTOR vTklHand=
          XMVectorSet(g_aTklHand[iTouchArea].mWorld.m[3][0],g_aTklHand[iTouchArea].mWorld.m[3][1],
                      g_aTklHand[iTouchArea].mWorld.m[3][2],0.0f);
        float fsgn;
        if(iTouchArea==0) fsgn=1.0f;
        else fsgn=(-1.0f);
        float fSideTklHandVal=2.0f+fsgn*sin(g_FingerRefAngleNow);
        fTouchVal+=fSideTklHandVal;
        vCenter+=fSideTklHandVal*(vTklHand-vCenter)/fTouchVal;
      }
    }
    XMVECTOR vPos0=XMLoadFloat3(&(g_PmdxWork.aSimBodyNode[iSimBodyNode0].vPosNow));
    XMVECTOR vPos1=XMLoadFloat3(&(g_PmdxWork.aSimBodyNode[iSimBodyNode1].vPosNow));
    XMVECTOR vDiff=vPos1-vPos0;
    float fDiff_x=XMVectorGetX(vDiff);
    float fDiff_y=XMVectorGetY(vDiff);
    float fDiff_z=XMVectorGetZ(vDiff);
    float fDiffSq=fDiff_x*fDiff_x+fDiff_y*fDiff_y+fDiff_z*fDiff_z;
    float fTCenter=XMVectorGetX(XMVector3Dot(vDiff,vCenter-vPos0))/fDiffSq;
    XMVECTOR vCRes=vPos0+fTCenter*vDiff;
    XMVECTOR vDiffCenter=vCRes-vCenter;
    float fLenCenter=XMVectorGetX(XMVector3Length(vDiffCenter));
    XMVECTOR vForce=XMVectorSet(0.0f, 0.0f, 0.0f, 0.0f);
    if(fLenCenter>0.0f) vForce=fTouchVal*vDiffCenter/fLenCenter;
    if(vForce0) *vForce0+=5.0f*(1.0f-fTCenter)*vForce;
    if(vForce1) *vForce1+=5.0f*fTCenter*vForce;
  }
}

void UpdateStrength(float *fStrength,float fConst,float fDiff,float dt){
  *fStrength+=(fConst-fDiff)*dt;
  if(*fStrength<0.0f) *fStrength=0.0f;
  else if(*fStrength>=1.0f) *fStrength=1.0f;
}

// f̓̂𓮂
void move_body(float dt){
  XMVECTOR vForceWeist=XMVectorSet(0.0f, 0.0f, 0.0f, 0.0f);
  XMVECTOR vForceArmpitL=XMVectorSet(0.0f, 0.0f, 0.0f, 0.0f);
  XMVECTOR vForceArmpitR=XMVectorSet(0.0f, 0.0f, 0.0f, 0.0f);
  XMVECTOR vForceLegL=XMVectorSet(0.0f, 0.0f, 0.0f, 0.0f);
  XMVECTOR vForceLegR=XMVectorSet(0.0f, 0.0f, 0.0f, 0.0f);
  XMVECTOR vForceKneeL=XMVectorSet(0.0f, 0.0f, 0.0f, 0.0f);
  XMVECTOR vForceKneeR=XMVectorSet(0.0f, 0.0f, 0.0f, 0.0f);
  AddForceTickle(0, 0,2, &vForceWeist,&vForceArmpitL); // 
  AddForceTickle(1, 0,8, &vForceWeist,&vForceArmpitR); // E
  AddForceTickle(4, 5,6, &vForceLegL,&vForceKneeL); // 
  AddForceTickle(5, 11,12, &vForceLegR,&vForceKneeR); // 
  AddForceTickle(6, 6,7, &vForceKneeL,nullptr); // ӂ͂
  AddForceTickle(7, 12,13, &vForceKneeR,nullptr); // ӂ͂
  XMVECTOR vPosNow,vPosBase,vDiff;
  // ݂̓̑Ŝ̎ps
  XMMATRIX mLUBody;
  GetMatrixLUBody(&g_PmdxWork,&mLUBody);
  // 㔼g
  vPosNow=XMLoadFloat3(&(g_PmdxWork.aSimBodyNode[0].vPosNow));
  vPosNow+=dt*(g_leg_L_strength+g_leg_R_strength)*vForceWeist;
  if(g_bone_idx_ubody>=0){
    XMVECTOR vPosSrc=XMLoadFloat3(&g_ubody_pos);
    if((!IsTickled(-1))&&(g_reaction_tkl_time>10.0f)){
      vPosSrc=XMVectorSetZ(vPosSrc,XMVectorGetZ(vPosSrc)-g_ubody_breath_z*
                           (-cos(g_reaction_breath_time*2.0f*XM_PI)));
    }
    XMVECTOR vPosBaseRef=
      XMVector3Transform(vPosSrc,XMLoadFloat4x4(&g_mLUBodyInv));
    vPosBase=XMVector3Transform(vPosBaseRef,mLUBody);
    vDiff=vPosBase-vPosNow;
    vPosNow+=dt*(g_leg_L_strength+g_leg_R_strength)*vDiff;
  }
  UpdateSimBodyNodePos(&g_PmdxWork,0,vPosNow);
  // 
  vPosNow=XMLoadFloat3(&(g_PmdxWork.aSimBodyNode[2].vPosNow));
  vPosNow+=dt*vForceArmpitL;
  UpdateSimBodyNodePos(&g_PmdxWork,2,vPosNow);
  // E
  vPosNow=XMLoadFloat3(&(g_PmdxWork.aSimBodyNode[8].vPosNow));
  vPosNow+=dt*vForceArmpitR;
  UpdateSimBodyNodePos(&g_PmdxWork,8,vPosNow);
  // r
  vPosNow=XMLoadFloat3(&(g_PmdxWork.aSimBodyNode[5].vPosNow));
  vPosNow+=dt*g_leg_L_strength*vForceLegL;
  vPosBase=XMLoadFloat3(&g_leg_L_pos);
  vDiff=vPosBase-vPosNow;
  vPosNow+=dt*2.5f*(2.0f-g_leg_L_strength)*vDiff;
  UpdateSimBodyNodePos(&g_PmdxWork,5,vPosNow);
  UpdateStrength(&g_leg_L_strength,1.0f,XMVectorGetX(XMVector3Length(vDiff)),dt);
  // Er
  vPosNow=XMLoadFloat3(&(g_PmdxWork.aSimBodyNode[11].vPosNow));
  vPosNow+=dt*g_leg_R_strength*vForceLegR;
  vPosBase=XMLoadFloat3(&g_leg_R_pos);
  vDiff=vPosBase-vPosNow;
  vPosNow+=dt*2.5f*(2.0f-g_leg_R_strength)*vDiff;
  UpdateSimBodyNodePos(&g_PmdxWork,11,vPosNow);
  UpdateStrength(&g_leg_R_strength,1.0f,XMVectorGetX(XMVector3Length(vDiff)),dt);
  // Ђ
  vPosNow=XMLoadFloat3(&(g_PmdxWork.aSimBodyNode[6].vPosNow));
  vPosNow+=dt*g_knee_L_strength*vForceKneeL;
  vPosBase=XMLoadFloat3(&(g_knee_L_pos_now));
  vDiff=vPosBase-vPosNow;
  vPosNow+=dt*5.0f*(2.0f-g_knee_L_strength)*vDiff;
  UpdateSimBodyNodePos(&g_PmdxWork,6,vPosNow);
  UpdateStrength(&g_knee_L_strength,1.0f,XMVectorGetX(XMVector3Length(vDiff)),dt);
  // EЂ
  vPosNow=XMLoadFloat3(&(g_PmdxWork.aSimBodyNode[12].vPosNow));
  vPosNow+=dt*g_knee_R_strength*vForceKneeR;
  vPosBase=XMLoadFloat3(&(g_knee_R_pos_now));
  vDiff=vPosBase-vPosNow;
  vPosNow+=dt*5.0f*(2.0f-g_knee_R_strength)*vDiff;
  UpdateSimBodyNodePos(&g_PmdxWork,12,vPosNow);
  UpdateStrength(&g_knee_R_strength,1.0f,XMVectorGetX(XMVector3Length(vDiff)),dt);
  // 㔼g2
  if(g_bone_idx_ubody2>=0){
    XMVECTOR vPosSrc=XMLoadFloat3(&g_ubody2_pos);
    if((!IsTickled(-1))&&(g_reaction_tkl_time>10.0f)){
      vPosSrc=XMVectorSetZ(vPosSrc,XMVectorGetZ(vPosSrc)-g_ubody2_breath_z*
                           (-cos(g_reaction_breath_time*2.0f*XM_PI)));
    }
    XMVECTOR vPosBaseRef=
      XMVector3Transform(vPosSrc,XMLoadFloat4x4(&g_mLUBodyInv));
    vPosBase=XMVector3Transform(vPosBaseRef,mLUBody);
    vPosNow=XMLoadFloat3(&(g_PmdxWork.aSimBodyNode[1].vPosNow));
    vDiff=vPosBase-vPosNow;
    vPosNow+=dt*5.0f*vDiff;
    UpdateSimBodyNodePos(&g_PmdxWork,1,vPosNow);
  }
  // r
  int iBoneUBody;
  if(g_bone_idx_ubody2>=0) iBoneUBody=g_bone_idx_ubody2;
  else if(g_bone_idx_ubody>=0) iBoneUBody=g_bone_idx_ubody;
  if(iBoneUBody>=0){
    float fx,fy,fz;
    GetInitialBonePos(&fx,&fy,&fz,&(g_PmdxWork),iBoneUBody);
    XMVECTOR vUBodyPos=XMVectorSet(fx,fy,fz,0.0f);
    // r
    if(g_bone_idx_arm_L>=0){
      vPosNow=XMLoadFloat3(&(g_PmdxWork.aSimBodyNode[3].vPosNow));
      vPosBase=XMLoadFloat3(&g_arm_L_pos);
      vDiff=vPosBase-vPosNow;
      vPosNow+=dt*5.0f*vDiff;
      UpdateSimBodyNodePos(&g_PmdxWork,3,vPosNow);
    }
    // Er
    if(g_bone_idx_arm_R>=0){
      vPosNow=XMLoadFloat3(&(g_PmdxWork.aSimBodyNode[9].vPosNow));
      vPosBase=XMLoadFloat3(&g_arm_R_pos);
      vDiff=vPosBase-vPosNow;
      vPosNow+=dt*5.0f*vDiff;
      UpdateSimBodyNodePos(&g_PmdxWork,9,vPosNow);
    }
  }
  // g̋V~[V
  ForwardSimBody(&g_PmdxWork,dt);
}

// LMCɂF\
void RenderListLMCHand(ConstantBuffer &cb1){
  XMMATRIX mWorld,mFinger,mWork;
  LMCHand *wkLMCHand;
  int nowLeftRight,iFinger,iJoint;

  cb1.TexStrength=0.0f;
  cb1.SphStrength=0.0f;
  cb1.SpaStrength=0.0f;
  cb1.SPower=3.0;
  cb1.SCol=XMFLOAT3(0.0f, 0.0f, 0.0f);
  // Set vertex buffer
  UINT stride = sizeof( SimpleVertex );
  UINT offset = 0;
  g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pVertexBufferCube, &stride, &offset );
  // Set index buffer
  g_pImmediateContext->IASetIndexBuffer( g_pIndexBufferCube, DXGI_FORMAT_R16_UINT, 0 );
  // Жʕ`
  g_pImmediateContext->RSSetState(g_pRasterizerStateSingleSide);

  wkLMCHand=g_listLMCHand;
  while(wkLMCHand){
    nowLeftRight=AnsLeftRightLMCHand(wkLMCHand);
    if(nowLeftRight!=0){
      // 
      cb1.DCol=XMFLOAT4(1.0f, 0.8f, 1.0f, 1.0f);
      cb1.ACol=XMFLOAT3(0.8f, 0.5f, 0.8f);
      mWorld=XMLoadFloat4x4(&(wkLMCHand->mWorld));
      mWorld=get_mLMCHandPalm() * mWorld * g_mWorldLMC;
      cb1.mWorld = XMMatrixTranspose(mWorld);
      g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
      g_pImmediateContext->DrawIndexed( 36, 0, 0 );
      // LMCɂۂ̎w挟oʒu(ڐGɎgʒuƂ͈قȂ)
      if(g_flgFingerPosVisible){
        cb1.DCol=XMFLOAT4(0.0f, 1.0f, 0.0f, 1.0f);
        cb1.ACol=XMFLOAT3(0.0f, 1.0f, 0.0f);
        for(iFinger=0;iFinger<5;iFinger++){
          if(wkLMCHand->validFinger[iFinger]){
            mWorld=XMMatrixScaling(5.0f,5.0f,5.0f);
            mWork=XMMatrixTranslationFromVector(XMLoadFloat3(&wkLMCHand->vFingerPos[iFinger]));
            mWorld=mWorld*mWork*g_mWorldLMC;
            cb1.mWorld = XMMatrixTranspose(mWorld);
            g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
            g_pImmediateContext->DrawIndexed( 36, 0, 0 );
          }
        }
      }
      // w
      cb1.DCol=XMFLOAT4(1.0f, 0.7f, 1.0f, 1.0f);
      cb1.ACol=XMFLOAT3(0.8f, 0.1f, 0.8f);
      for(iFinger=0;iFinger<5;iFinger++){
        mFinger=get_mLMCFinger(iFinger);
        for(iJoint=0;iJoint<3;iJoint++){
          mWorld=XMLoadFloat4x4(&(wkLMCHand->mWJoint[iFinger][iJoint]));
          mWorld=mFinger*mWorld*g_mWorldLMC;
          cb1.mWorld = XMMatrixTranspose(mWorld);
          g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
          g_pImmediateContext->DrawIndexed( 36, 0, 0 );
        }
      }
    }
    wkLMCHand=wkLMCHand->next;
  }
}

// `
void RenderCross(ConstantBuffer &cb1){
  // Set vertex buffer
  UINT stride = sizeof( SimpleVertex );
  UINT offset = 0;
  g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pVertexBufferCross, &stride, &offset );
  // Set index buffer
  g_pImmediateContext->IASetIndexBuffer( g_pIndexBufferCross, DXGI_FORMAT_R16_UINT, 0 );
  // ގ̐ݒ
  cb1.TexStrength=0.0f;
  cb1.SphStrength=0.0f;
  cb1.SpaStrength=0.0f;
  cb1.DCol=XMFLOAT4(0.7f, 0.8f, 0.8f, 1.0f);
  cb1.ACol=XMFLOAT3(0.3f, 0.6f, 0.6f);
  cb1.SCol=XMFLOAT3(0.3f, 0.2f, 0.2f);
  cb1.SPower=10.0;
  //Жʕ`
  g_pImmediateContext->RSSetState(g_pRasterizerStateSingleSide);
  // `
  cb1.mWorld = XMMatrixTranspose(XMMatrixIdentity());
  g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
  g_pImmediateContext->DrawIndexed( 36*11, 0, 0 );
}

void RenderForOneEye(int eye, XMMATRIX &nowRollPitchYawPos){
  ConstantBuffer cb1;
  // Set the view matrix
  XMVECTOR Eye;
  if(eye==0)
    Eye = XMVector3Transform(XMVectorSet(-g_sbase/2, g_eyeheight, g_eyeforward,
                                         0.0f),nowRollPitchYawPos);
  else
    Eye = XMVector3Transform(XMVectorSet(g_sbase/2, g_eyeheight, g_eyeforward,
                                         0.0f),nowRollPitchYawPos);
  XMVECTOR At=Eye+nowRollPitchYawPos.r[2];
  XMVECTOR Up = nowRollPitchYawPos.r[1];
  XMMATRIX View = XMMatrixLookAtLH( Eye, At, Up );
  cb1.mView = XMMatrixTranspose( View );

  // Жڗpʃ^[Qbg̐ݒƃNA
  D3D11_VIEWPORT vp;
  vp.Width = (FLOAT)g_width/2;
  vp.Height = (FLOAT)g_height;
  vp.MinDepth = 0.0f;
  vp.MaxDepth = 1.0f;
  if(eye==0) vp.TopLeftX = 0;
  else vp.TopLeftX = (FLOAT)g_width/2;
  vp.TopLeftY = 0;
  g_pImmediateContext->RSSetViewports( 1, &vp );
  g_pImmediateContext->OMSetRenderTargets( 1, &g_pOVRRenderTargetView, g_pDepthStencilView );
  g_pImmediateContext->ClearRenderTargetView( g_pOVRRenderTargetView, Colors::MidnightBlue );
  g_pImmediateContext->ClearDepthStencilView( g_pDepthStencilView, D3D11_CLEAR_DEPTH, 1.0f, 0 );
  g_pImmediateContext->VSSetShader( g_pVertexShader, nullptr, 0 );
  g_pImmediateContext->VSSetConstantBuffers( 0, 1, &g_pConstantBuffer );
  g_pImmediateContext->PSSetShader( g_pPixelShader, nullptr, 0 );
  g_pImmediateContext->PSSetConstantBuffers( 0, 1, &g_pConstantBuffer );
  // Set the projection matrix
  if(eye==0) cb1.mProjection = XMMatrixTranspose( g_ProjectionL );
  else cb1.mProjection = XMMatrixTranspose( g_ProjectionR );
  // Set the input layout
  g_pImmediateContext->IASetInputLayout( g_pVertexLayout );
  // Set primitive topology
  g_pImmediateContext->IASetPrimitiveTopology( D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST );

  // ufBOXe[ggp
  g_pImmediateContext->OMSetBlendState( g_pBlendState, g_blendFactor, 0xffffffff );

  cb1.ZOffset=0.0f; // PMD/PMX`掞̂ݎgp
  // `
  RenderCross(cb1);
  //ȈՃnh`
  RenderTklHand(cb1);
  //LMCnh`
  RenderListLMCHand(cb1);
  //ڐGF󋵕\
  if(g_flgTouchVisible) RenderTouchRecog(cb1);
  // PMD/PMX`
  g_pImmediateContext->VSSetShader( g_pPMDXVertexShader, nullptr, 0 );
  g_pImmediateContext->IASetInputLayout( g_pPMDXVertexLayout );
  render_pmdx(&g_PmdxWork,cb1);
  // UIpl`
  g_pImmediateContext->VSSetShader( g_pVertexShader, nullptr, 0 );
  g_pImmediateContext->IASetInputLayout( g_pVertexLayout );
  RenderUIPanels(cb1,&g_mEyeBase);

  // ŏI^[Qbgւ̕`揀
  g_pImmediateContext->OMSetRenderTargets( 1, &g_pRenderTargetView, nullptr );
  g_pImmediateContext->PSSetShaderResources(0, 1, &g_pOVRShaderResourceView);
  g_pImmediateContext->VSSetShader( g_pOVRVertexShader, nullptr, 0 );
  // ufBOXe[ggpȂ
  g_pImmediateContext->OMSetBlendState( nullptr, g_blendFactor, 0xffffffff );
  // cݕ␳p萔obt@
  // RenderTiny_Device.cpp RenderDevice::FinishScene1() ̒`Qlɐݒ
  OVRConstantBuffer ovr_cb;
  float w = float(vp.Width) / float(g_width),
        h = float(vp.Height) / float(g_height),
        x = float(vp.TopLeftX) / float(g_width),
        y = float(vp.TopLeftY) / float(g_height);
  float lensViewportShift;
  if(eye==0) lensViewportShift=g_lensViewportShift;
  else lensViewportShift=(-g_lensViewportShift);
  ovr_cb.LensCenter.x = x + (w + lensViewportShift * 0.5f)*0.5f;
  ovr_cb.LensCenter.y = y + h*0.5f;
  ovr_cb.ScreenCenter.x = x + w*0.5f;
  ovr_cb.ScreenCenter.y = y + h*0.5f;
  float scaleFactor = 1.0f / g_distortionScale;
  ovr_cb.Scale.x=(w/2) * scaleFactor;
  float as = float(vp.Width) / float(vp.Height);
  ovr_cb.Scale.y=(h/2) * scaleFactor * as;
  ovr_cb.ScaleIn.x = (2.0f/w);
  ovr_cb.ScaleIn.y = (2.0f/h) / as;
  ovr_cb.HmdWarpParam.x = g_HMDInfo.DistortionK[0];
  ovr_cb.HmdWarpParam.y = g_HMDInfo.DistortionK[1];
  ovr_cb.HmdWarpParam.z = g_HMDInfo.DistortionK[2];
  ovr_cb.HmdWarpParam.w = g_HMDInfo.DistortionK[3];
  vp.Width = (FLOAT)g_width;
  vp.TopLeftX = 0;
  g_pImmediateContext->RSSetViewports( 1, &vp );
  g_pImmediateContext->VSSetConstantBuffers( 0, 1, &g_pOVRConstantBuffer );
  g_pImmediateContext->PSSetShader( g_pOVRPixelShader, nullptr, 0 );
  g_pImmediateContext->PSSetConstantBuffers( 0, 1, &g_pOVRConstantBuffer );
  g_pImmediateContext->UpdateSubresource( g_pOVRConstantBuffer, 0, nullptr, &ovr_cb, 0, 0 );
  // Set the input layout for OVR
  g_pImmediateContext->IASetInputLayout( g_pOVRVertexLayout );
  // Set vertex buffer for OVR
  UINT ovr_stride = sizeof( OVRVertex );
  UINT ovr_offset = 0;
  if(eye==0) g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pOVRVertexBufferL, &ovr_stride, &ovr_offset );
  else g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pOVRVertexBufferR, &ovr_stride, &ovr_offset );
  // Set index buffer for OVR
  g_pImmediateContext->IASetIndexBuffer( g_pOVRIndexBuffer, DXGI_FORMAT_R16_UINT, 0 );
  // Set primitive topology for OVR
  g_pImmediateContext->IASetPrimitiveTopology( D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST );
  // cݕ␳摜ŏI^[Qbg֕`
  g_pImmediateContext->DrawIndexed( 6, 0, 0 );
}

// ZT[l̎擾
void ReadOVRSensor(){
  if(g_pSFusion){
    // ݂̃ZT[lǂݏo
    OVR::Quatf hmdOrient = g_pSFusion->GetOrientation();
    float nowPitch, nowRoll;
    hmdOrient.GetEulerAngles<OVR::Axis_Y, OVR::Axis_X, OVR::Axis_Z>(&g_NowYaw, &nowPitch, &nowRoll);

    // lƂ̍߂(Yaŵ)
    float dYaw=g_NowYaw-g_InitYaw;

    // _̎ppɔfB
    g_EyeYaw=(-dYaw);
    g_EyePitch=(-nowPitch);
    g_EyeRoll=nowRoll;
  }
}

// _ʒüړ
void MoveEyePosBaseYaw(float dt,XMMATRIX *mEyeBase){
  g_EyeBaseYaw+=dt*g_EyeBaseYawVelocity;
  *mEyeBase=XMMatrixRotationY(g_EyeBaseYaw);
  g_EyePos.x+=dt*(g_EyeVelocity.x*XMVectorGetX(mEyeBase->r[0])+
                  g_EyeVelocity.z*XMVectorGetX(mEyeBase->r[2]));
  g_EyePos.y+=dt*g_EyeVelocity.y;
  g_EyePos.z+=dt*(g_EyeVelocity.x*XMVectorGetZ(mEyeBase->r[0])+
                  g_EyeVelocity.z*XMVectorGetZ(mEyeBase->r[2]));
  mEyeBase->r[3]=XMVectorSet(g_EyePos.x,g_EyePos.y,g_EyePos.z,1.0f);
}

// ZXbh
void ThredSimulatePys(void *pDmy){
  int cont=1;
  int pysComputing;
  float dt_pys;

  while(cont){
    WaitForSingleObject(g_hEventPys, INFINITE);
    pysComputing=g_PysComputing;
    ResetEvent(g_hEventPys);
    switch(pysComputing){
    case 0:
    case 2:
      break;
    case 1:
      dt_pys=(g_now_time-g_now_time_pys)/1000.0f;
      g_now_time_pys=g_now_time;
      SimulatePys(dt_pys);
      EnterCriticalSection(&g_CriticalSection);
      g_PysComputing=2;
      LeaveCriticalSection(&g_CriticalSection);
      break;
    case 3:
      cont=0;
      break;
    }
  }
}

void Render(){
  // ̎擾
  ULONGLONG timeCur = GetTickCount64();
  float dt=(timeCur-g_now_time)/1000.0f;
  g_now_time=timeCur;

  // ZT[l̎擾
  ReadOVRSensor();

  // _̈ړƉ]
  MoveEyePosBaseYaw(dt,&g_mEyeBase);

  // ȈՃnh𓮂
  MoveTklHand(dt);

  // _̎ps
  XMVECTOR eyePos=XMLoadFloat3(&g_EyePos);
  XMMATRIX nowRollPitchYawPos=XMMatrixMultiply(
                               XMMatrixMultiply(
                                XMMatrixMultiply(
                                 XMMatrixRotationZ(g_EyeRoll),
                                 XMMatrixRotationX(g_EyePitch)),
                                XMMatrixRotationY(g_EyeYaw)),
                               g_mEyeBase);

  // LMC[hs߂
  if(g_flgLMCMountedOnHMD){ // LMCHMDɃ}EgĂ
    XMMATRIX mLMCMounter;
    mLMCMounter.r[0]=XMVectorSet(-1.0f, 0.0f, 0.0f, 0.0f);
    mLMCMounter.r[1]=XMVectorSet(0.0f, 0.0f, 1.0f, 0.0f);
    mLMCMounter.r[2]=XMVectorSet(0.0f, 1.0f, 0.0f, 0.0f);
    mLMCMounter.r[3]=XMVectorSet(0.0f, g_eyeheight, g_eyeforward+0.6f, 1.0f);
    g_mWorldLMC=XMMatrixScaling(0.01f,0.01f,0.01f)*mLMCMounter*nowRollPitchYawPos;
  }
  else // LMC͑̏ɒuĂ
    g_mWorldLMC=XMMatrixScaling(0.01f,0.01f,0.01f)*XMMatrixTranslation(0.0f,-3.0f,3.0f)*g_mEyeBase;

  // LMCnh𓮂
  RecognizeLMCHand(&g_listLMCHand,dt);

  // ̔F
  RecognizeTickle(dt);

  // f𓮂
  change_restriction_pose(dt);
  if(g_flg_SimBodyEnable) move_body(dt);
  ApplySimBody2Bone(&g_PmdxWork);
  move_face(dt);
  move_head(dt,nowRollPitchYawPos);
  move_ankles(dt);
  apply_bone_morph(&g_PmdxWork);
  GiveRotate(&g_PmdxWork);
  // g𓮂
  CrucifyModel(&g_PmdxWork,0);
  // Bullet
  EnterCriticalSection(&g_CriticalSection);
  int pysComputing=g_PysComputing; // Bullet̃XbhԂ擾
  LeaveCriticalSection(&g_CriticalSection);
  // ỎZIĂAʂo
  GetBoneStateFromBulletWorld(&g_PmdxWork,pysComputing);
  if(pysComputing==2){
    g_PysComputing=0;
  }
  if(pysComputing==0){
    // Bulletɔf
    SendLMCHandToBulletWorld(&g_listLMCHand,&g_mWorldLMC);
    SendBoneStateToBulletWorld(&g_PmdxWork);
    // Z̎sJn
    g_PysComputing=1;
    SetEvent(g_hEventPys);
  }
  ValidateAllWBone(&g_PmdxWork);
  // {[obt@XV
  UpdateBoneBuf(&g_PmdxWork);
  UpdateAllBoneBufCB();
  // _obt@XV
  if(g_PmdxWork.isVertUpdated){
    g_pImmediateContext->UpdateSubresource( g_PmdxWork.pVertexBuffer, 0, nullptr,
                                            g_PmdxWork.aVertex, 0, 0 );
  }
  // obt@XV̕KvǗ
  SetLastAllWBone(&g_PmdxWork);
  g_PmdxWork.isVertUpdated=0;

  // {[[tKpÕ[Jsɖ߂
  cancel_bone_morph(&g_PmdxWork);

  // UIpl^p
  OperateUIPanels(nowRollPitchYawPos.r[2],&g_mEyeBase,g_listLMCHand,&g_mWorldLMC,dt);

  // ŏI^[QbgNA
  g_pImmediateContext->OMSetRenderTargets( 1, &g_pRenderTargetView, nullptr );
  g_pImmediateContext->ClearRenderTargetView( g_pRenderTargetView, Colors::Black );

  // `
  RenderForOneEye(0, nowRollPitchYawPos);
  RenderForOneEye(1, nowRollPitchYawPos);

  g_pSwapChain->Present( 0, 0 );
}
